#include "wcDialogConstant.h"
#include "wcToolConstant.h"

#define LAYER_ZD	"宗地"
#define TABLE_XXGJ	"宗地信息挂接表"

#define ID_COMBO_XZ			10001
#define ID_COMBO_CUN			10002
#define ID_COMBO_CQR			10003
#define ID_EDIT_LXDH		10004
#define ID_COMBO_DZ1			10005
#define ID_COMBO_NZ1			10006
#define ID_COMBO_XZ1			10007
#define ID_COMBO_BZ1			10008
#define ID_EDIT_JL			10009
#define ID_EDIT_FWZL		10010
#define ID_EDIT_CQLY		10011
#define ID_EDIT_ZU			10012
#define ID_ZDSZ_GROUP		10013
#define ID_XZQ_GROUP		10014
#define ID_CQEXX_GROUP		10015
#define	ID_BTN_SAVE			10016
#define	ID_BTN_XXGJ			10017
#define ID_COMBO_CHY		10018
#define ID_COMBO_HTY		10019
#define ID_EDIT_CHRQ		10020
#define ID_EDIT_XZCODE		10021
#define ID_EDIT_CUNCODE		10022
#define ID_BTN_SELXZ		10023
#define ID_BTN_SELCUN		10024

#ifndef ES_DATE
#define ES_DATE 0x4000 // 日期
#define ES_TIME 0x8000 // 时间
#endif

#define wdMsgEndScript	6

wkView view;
wkGeoset geoset;
array aCtrIds = { ID_COMBO_XZ, ID_COMBO_CUN, ID_COMBO_CQR, ID_EDIT_LXDH,
ID_COMBO_DZ1, ID_COMBO_NZ1, ID_COMBO_XZ1, ID_COMBO_BZ1,
ID_EDIT_JL,
ID_EDIT_FWZL, ID_EDIT_CQLY, ID_EDIT_ZU, ID_COMBO_CHY, ID_COMBO_HTY,
ID_EDIT_CHRQ};
array aFields = { "乡镇", "村", "产权人", "电话", "东", "南", "西", "北", "勘丈记事", "房屋坐落",
	"产权来源", "组", "测绘员", "绘图员", "测绘日期" };
array aCtrIdGJ = { ID_COMBO_XZ, ID_COMBO_CUN, ID_EDIT_FWZL, ID_EDIT_CQLY,
ID_EDIT_ZU };
array aFieldGJ = { "乡镇", "村", "房屋坐落", "产权来源", "组" };
string sFieldGJ = "乡镇 ,村 ,房屋坐落, 产权来源, 组";

void SearchZDInfo(wkDialog& dlg) {
wkLayer layerZD = geoset.getLayer(LAYER_ZD);
if (!layerZD.handle()) {
	return;
}
string sCQR = dlg.getText(ID_COMBO_CQR);
if (sCQR.isEmpty()) {
	message("请先输入【产权人】!");
	return;
}
wkDb db = layerZD.getDb();
string sql;
sql.format("select count(产权人) from %s where 产权人 = '%s'", TABLE_XXGJ, sCQR);
array aCount;
aCount.removeAll();
aCount = db.getDataBySQL(sql, 1);
array aVals;
aVals.removeAll();
sql.format("select %s from %s where 产权人 = '%s'", sFieldGJ, TABLE_XXGJ, sCQR);
aVals = db.getDataBySQL(sql, 10000);
int nCount = atoi(aCount[0]);
if (nCount == 1) {
	for (int i = 0; i < aVals.getSize(); i++) {
		if (aVals[i].isEmpty()) {
			continue;
		}
		dlg.setText(aCtrIdGJ[i], aVals[i]);
	}
} else if (nCount == 0) {
	return;
} else if (nCount > 1) {
	array aSel;
	aSel.removeAll();
	for (int i = 0; i < aVals.getSize(); i += aFieldGJ.getSize()) {
		string s;
		for (int j = i; j < i + aFieldGJ.getSize(); j++) {
			s += aVals[j] + ",";
		}
		s.trimRight(",");
		aSel.add(s);
	}

	string s = view.dlgSelect("请选择(乡镇 ,村 ,房屋坐落, 产权来源, 组)", aSel, "", true);
	if (s.isEmpty()) {
		return;
	}
	wkDb d1;
	aVals.removeAll();
	aVals = d1.sqlSubsByDeli(s, ",");
	for (i = 0; i < aVals.getSize(); i++) {
		dlg.setText(aCtrIdGJ[i], aVals[i]);
	}
}
}

void ClearValues(wkDialog& dlg) {
for (int i = 0; i < aCtrIds.getSize(); i++) {
	dlg.setText(aCtrIds[i], "");
}
}
string getFinishPath() {
	string s = geoset.getName();
	s.replace("\\", "/");
	s = s.left(s.reverseFind("/"));
	if (s.right(1) != "/")
		s += "/";
	s += "house.fin";
	return s;
}
string TemplateDb() {
return WsGetAppFolder() + "Templates/WalkTemplate.sqlite";
}

//从public_code中得到乡镇
void SetXZVals(wkDialog& dlg) {
wkDb dbMb;
array vals;
vals.removeAll();
string sMbPath = TemplateDb();
if (!dbMb.open(sMbPath)) {
	dbMb.close();
	return;
}
string sql;
sql.format(
		"select code_value|| ' ' ||code from public_codes where code_class=%d",
		10);


vals = dbMb.getDataBySQL(sql, 50000);
dbMb.close();
if (vals.getSize() > 0) {
	for (int i = 0; i < vals.getSize(); i++) {
		int nFid = vals[i].find(" ");
		if (nFid > 0) {
			dlg.insertItem(ID_COMBO_XZ, i, vals[i].left(nFid));
		}
	}
}
}

//根据行政代码获取村
void SetCunVals(string sXZQ, wkDialog& dlg) {
wkDb dbMb;
array vals;
vals.removeAll();
string sMbPath = TemplateDb();
if (!dbMb.open(sMbPath)) {
	dbMb.close();
	return;
}

string sql;
sql.format("select code_value || ' ' || code from public_codes \
where code_class=%d and length(code) > 9 \
and substr(code,1,9) in (select code from public_codes where code_value='%s')",
11 , sXZQ);
vals = dbMb.getDataBySQL(sql, 50000);
dbMb.close();

if (vals.getSize() > 0) {
	for (int i = 0; i < vals.getSize(); i++) {
		int nFid = vals[i].find(" ");
		if (nFid > 0) {
			dlg.insertItem(ID_COMBO_CUN, i, vals[i].left(nFid));
		}
	}
}
}
void SaveValues(wkDialog& dlg) {
wkFile file;

wkLayer layerZD = geoset.getLayer(LAYER_ZD);
if (!layerZD.handle()) {
	return;
}
if (layerZD.getSelectionCount()==0)
	return;
int nLastFeatureId = layerZD.getSelectionAt(0).getId();
for (int i = 0; i < aFields.getSize(); i++) {
	int nFld = layerZD.getFieldIndex(aFields[i]);
	if (nFld == -1) {
		continue;
	}
	string s = dlg.getText(aCtrIds[i]);
	if (s.isEmpty()) {
		continue;
	}
	wkFeature fea = layerZD.getFeature(nLastFeatureId);
	fea.setInfo(layerZD, nFld, s);
}
LoadSetComboHistory(dlg, ID_COMBO_CHY, "测绘员", false);
LoadSetComboHistory(dlg, ID_COMBO_HTY, "绘图员", false);

layerZD.save();


file.iniWrite(LAYER_ZD + toString(nLastFeatureId), "attributeZongDi", "1",
		getFinishPath());
message("保存成功!");
}

void LoadValues(wkDialog& dlg) {
wkFile file;
int nLastFeatureId = atoi(
		file.iniGet("ZD", "nLastFeatureId", "", "wkGlobeDump.ini"));
wkLayer layerZD = geoset.getLayer(LAYER_ZD);
if (layerZD.handle() != 0) {
	if (layerZD.getSelectionCount() == 0 && layerZD.getFeatureCount())
	{
		layerZD.addToSelection(layerZD.getFeatureAt(0));
		nLastFeatureId = layerZD.getFeatureAt(0).getId();
	}
	if (layerZD.getSelectionCount() == 1) {
		int nSelFid = layerZD.getSelectionAt(0).getId();
		if (nSelFid == nLastFeatureId) {
			return;
		}
		ClearValues(dlg);
		nLastFeatureId = nSelFid;
	} else {
		ClearValues(dlg);
		file.iniWrite("ZD", "nLastFeatureId", "-1", "wkGlobeDump.ini");
		file.close();
		return;
	}
} else if (layerZD.handle() == 0) {
	ClearValues(dlg);
	file.iniWrite("ZD", "nLastFeatureId", "-1", "wkGlobeDump.ini");
	file.close();
	return;
}

if (nLastFeatureId == -1) {
	ClearValues(dlg);
	file.iniWrite("ZD", "nLastFeatureId", "-1", "wkGlobeDump.ini");
	file.close();
	return;
}

for (int i = 0; i < aFields.getSize(); i++) {

	wkFeature fea = layerZD.getFeature(nLastFeatureId);
	string s = fea.getInfo(layerZD, aFields[i]);

	if (s.isEmpty()) {
		continue;
	}
	dlg.setText(aCtrIds[i], s);
}
file.iniWrite("ZD", "nLastFeatureId", toString(nLastFeatureId),
		"wkGlobeDump.ini");
file.close();

wkDb db;
db = layerZD.getDb();
array aCQR;
aCQR.removeAll();
string sql;
sql.format("select distinct 产权人 from %s order by 产权人", TABLE_XXGJ);
aCQR = db.getDataBySQL(sql, 100000);
if (aCQR.getSize() > 0) {
	for (i = 0; i < aCQR.getSize(); i++) {
		dlg.insertItem(ID_COMBO_CQR, i, aCQR[i]);
	}
}

SetXZVals(dlg);
SetCunVals(dlg.getText(ID_COMBO_XZ), dlg);
}

void Respond(wkDialog& dlg, int ctrlId, int act) {
if (act == wdMapLbtnUp) {
	LoadValues(dlg);
} else if (act == wdMsgBnClicked) {
	if (ctrlId == ID_BTN_SAVE) {
		SaveValues(dlg);
	} else if (ctrlId == ID_BTN_XXGJ) {
		SearchZDInfo(dlg);
	}
} else if (act == wdMsgSelchange) {
	if (ctrlId == ID_COMBO_XZ) {
		dlg.clear(ID_COMBO_CUN);
		SetCunVals(dlg.getText(ID_COMBO_XZ), dlg);
	}
} else if (act == wdMsgEndScript) {
	SaveValues(dlg);
}
}
bool stringInArray(string s, array& a) {
for (int i = 0; i < a.getSize(); ++i) {
	if (s.compareNoCase(a[i]) == 0)
		return true;
}
return false;
}
void LoadSetComboHistory(wkDialog& dlg, int ctrlId, string sec, bool bLoad) {
wkFile ini;
string sFile = "walk.ini";
if (bLoad) {
	int nC = atoi(ini.iniGet(sec, "count", "0", sFile));
	dlg.clear(ctrlId);
	for (int i = 0; i < nC; ++i) {
		string sItem;
		sItem.format("Item%d", i);
		string sVal = ini.iniGet(sec, sItem, "", sFile);
		if (!sVal.isEmpty())
			dlg.insertItem(ctrlId, i, sVal);
	}
} else {
	int nC = dlg.count(ctrlId);
	string sText = dlg.getText(ctrlId);
	if (!sText.isEmpty()) {
		array a;
		for (int t = 0; t < nC; ++t) {
			a.add(dlg.getText(ctrlId, t));
		}
		if (!stringInArray(sText, a))
			dlg.insertItem(ctrlId, nC, sText);
	}
	nC = dlg.count(ctrlId);
	ini.iniWrite(sec, "count", toString(nC), sFile);
	for (int i = 0; i < nC; ++i) {
		string sItem;
		sItem.format("Item%d", i);
		ini.iniWrite(sec, sItem, dlg.getText(ctrlId, i), sFile);
	}
}
}
void CreateDlg(wkDialog& dlg) {
dlg.create("宗地属性");
int x = 3, y = 5;

y += 8;
dlg.addCtrl(ID_CQEXX_GROUP, wdCtrlButton, x - 2, y - 3, 160, 113, BS_GROUPBOX,
		"宗地信息");
y += 8;
dlg.addCtrl("产权人:", x + 2, y + 3);
dlg.addCtrl(ID_COMBO_CQR, wdCtrlComboBox, x + 28, y + 2, 127, 15, CBS_DROPDOWN);

dlg.addCtrl(ID_BTN_XXGJ, wdCtrlButton, x + 108, y - 19, 50, 15, WS_BORDER,
		"信息挂接");
dlg.setAction(ID_BTN_XXGJ, wdMsgBnClicked);
dlg.show(ID_BTN_XXGJ, 0);

y += 20;
dlg.addCtrl("组:", x + 2, y + 3);
dlg.addCtrl(ID_EDIT_ZU, wdCtrlEdit, x + 15, y + 2, 45, 15, ES_LEFT);

dlg.addCtrl("房屋坐落:", x + 65, y + 3);
dlg.addCtrl(ID_EDIT_FWZL, wdCtrlEdit, x + 100, y + 2, 55, 15, ES_LEFT);

y += 20;
dlg.addCtrl("产权来源:", x + 2, y + 3);
dlg.addCtrl(ID_EDIT_CQLY, wdCtrlEdit, x + 35, y + 2, 25, 15, ES_LEFT);
dlg.addCtrl("联系电话:", x + 65, y + 3);
dlg.addCtrl(ID_EDIT_LXDH, wdCtrlEdit, x + 100, y + 2, 55, 15, ES_LEFT);

y += 20;
dlg.addCtrl("乡镇(街道):", x + 2, y + 3);
dlg.addCtrl(ID_COMBO_XZ, wdCtrlComboBox, x + 50, y + 2, 105, 15, CBS_DROPDOWN);

// 	dlg.addCtrl(ID_EDIT_XZCODE, wdCtrlEdit, x+50, y+2, 60, 15, ES_LEFT);
// 	dlg.show(ID_EDIT_XZCODE,0);
y += 20;
dlg.addCtrl("行政村(社区):", x + 2, y + 3);
dlg.addCtrl(ID_COMBO_CUN, wdCtrlComboBox, x + 50, y + 2, 105, 15, CBS_DROPDOWN);
// 	dlg.addCtrl(ID_EDIT_CUNCODE, wdCtrlEdit, x+50, y+2, 60, 15, ES_LEFT);
// 	dlg.show(ID_EDIT_CUNCODE, 0);
dlg.setAction(ID_COMBO_XZ, wdMsgSelchange);

y += 28;
dlg.addCtrl(ID_ZDSZ_GROUP, wdCtrlButton, x - 2, y - 3, 160, 95, BS_GROUPBOX,
		"宗地四至");
y += 8;
dlg.addCtrl("东至:", x + 2, y + 3);
dlg.addCtrl(ID_COMBO_DZ1, wdCtrlComboBox, x + 23, y + 2, 132, 15, CBS_DROPDOWN);
dlg.setAction(ID_COMBO_DZ1, wdMsgSelchange);
y += 20;
dlg.addCtrl("南至:", x + 2, y + 3);
dlg.addCtrl(ID_COMBO_NZ1, wdCtrlComboBox, x + 23, y + 2, 132, 15, CBS_DROPDOWN);
dlg.setAction(ID_COMBO_NZ1, wdMsgSelchange);
y += 20;
dlg.addCtrl("西至:", x + 2, y + 3);
dlg.addCtrl(ID_COMBO_XZ1, wdCtrlComboBox, x + 23, y + 2, 132, 15, CBS_DROPDOWN);
dlg.setAction(ID_COMBO_XZ1, wdMsgSelchange);
y += 20;
dlg.addCtrl("北至:", x + 2, y + 3);
dlg.addCtrl(ID_COMBO_BZ1, wdCtrlComboBox, x + 23, y + 2, 132, 15, CBS_DROPDOWN);
dlg.setAction(ID_COMBO_BZ1, wdMsgSelchange);
array comdata = { "道路", "空地", "河", "桑地", "水田", "水塘", "林地" };
for (int i = 0; i < comdata.getSize(); ++i) {
	dlg.insertItem(ID_COMBO_DZ1, i, comdata[i]);
	dlg.insertItem(ID_COMBO_NZ1, i, comdata[i]);
	dlg.insertItem(ID_COMBO_XZ1, i, comdata[i]);
	dlg.insertItem(ID_COMBO_BZ1, i, comdata[i]);
}

y += 25;
dlg.addCtrl(20001, wdCtrlButton, x - 2, y + 6, 160, 100, BS_GROUPBOX,
		"勘丈调查特殊情况记录");
dlg.addCtrl(ID_EDIT_JL, wdCtrlEdit, x + 2, y + 20, 153, 30, ES_LEFT);

y += 50;
dlg.addCtrl("测绘员:", x + 2, y + 4);
dlg.addCtrl(ID_COMBO_CHY, wdCtrlComboBox, x + 40, y + 2, 115, 15, CBS_DROPDOWN);
LoadSetComboHistory(dlg, ID_COMBO_CHY, "测绘员", true);

y += 18;
dlg.addCtrl("绘图员:", x + 2, y + 4);
dlg.addCtrl(ID_COMBO_HTY, wdCtrlComboBox, x + 40, y + 2, 115, 15, CBS_DROPDOWN);
LoadSetComboHistory(dlg, ID_COMBO_HTY, "绘图员", true);

y += 18;
dlg.addCtrl("测绘日期:", x + 2, y + 4);
dlg.addCtrl(ID_EDIT_CHRQ, wdCtrlEdit, x + 40, y + 2, 115, 15, ES_DATE);

y += 20;
dlg.addCtrl(ID_BTN_SAVE, wdCtrlButton, x - 2, y + 5, 161, 17, WS_BORDER, "保存");
dlg.setAction(ID_BTN_SAVE, wdMsgBnClicked);
dlg.setAction(wdMapLbtnUp);
wkFile file;
file.iniWrite("ZD", "nLastFeatureId", "-1", "wkGlobeDump.ini");
file.close();
LoadValues(dlg);
dlg.show(wdIdOk, 0);
dlg.show(wdIdCancel, 0);
dlg.setAction(wdMsgEndScript);
dlg.show();

}

void main(array args) {
	wkDialog dlg;
	CreateDlg(dlg);

	int ctrlId;
	while (1)
	{
		int act = dlg.peekAction(ctrlId);
		if (act == -1)
		{
			break;
		}

		//响应消息
		Respond(dlg, ctrlId, act);
	}
	/*
wkDialog dlg;
if (args.getSize() < 3) {
	CreateDlg(dlg);
} else {
	dlg.from((args[args.getSize()-3])); //对话框
		if (dlg.handle()==0)
			return;

		//callFuncByName("Respond", dlg, ctrlId, action);
		callFuncByName("Respond", dlg,
			atoi(args[args.getSize()-2]), atoi(args[args.getSize()-1]));
}
*/
}
