#include "wcDialogConstant.h"
#include "wcToolConstant.h"

#define LAYER_Z	"幢"

#define ID_COMBO_JZJG	10001
#define ID_EDIT_ZCC		10002
#define ID_EDIT_JCNF	10003
#define ID_EDIT_FID		10004
#define ID_BTN_SAVE		10005
#define ID_BTN_CANSLE	10006
#define ID_COMBO_ZHUANGHAO 10007

wkView view;
wkGeoset geoset;

array aCtrIds = { ID_COMBO_ZHUANGHAO, ID_COMBO_JZJG, ID_EDIT_ZCC, ID_EDIT_JCNF };
array aFields = { "幢号", "建筑结构", "总层次", "建成年份" };
string sField = "幢号,建筑结构 ,总层次 ,建成年份";

array aJG =
		{ "1 钢结构", "2 钢、钢筋混凝土结构", "3 钢筋混凝土结构", "4 混合结构", "5 砖木结构", "6 其他结构" };

void LoadValues(wkDialog& dlg) {
	int nFid = atoi(dlg.getText(ID_EDIT_FID));
	wkLayer layer = geoset.getLayer(LAYER_Z);
	wkFeature fea = layer.getFeature(nFid);
	if (!fea.handle()) {
		return;
	}
	for (int i = 0; i < aFields.getSize(); i++) {
		string s = fea.getInfo(layer, aFields[i]);
		if (s.isEmpty()) {
			continue;
		}
		if (aCtrIds[i] == ID_COMBO_JZJG) {
			for (int j = 0; j < aJG.getSize(); ++j) {
				if (atoi(aJG[j]) == atoi(s)) {
					dlg.setText(aCtrIds[i], aJG[j]);
					break;
				}
			}
		} else
			dlg.setText(aCtrIds[i], s);
	}
}

void SaveValues(wkDialog& dlg) {
	int nFid = atoi(dlg.getText(ID_EDIT_FID));
	wkLayer layer = geoset.getLayer(LAYER_Z);
	wkFeature fea = layer.getFeature(nFid);
	if (!fea.handle()) {
		return;
	}
	for (int i = 0; i < aFields.getSize(); i++) {
		string s = dlg.getText(aCtrIds[i]);
		if (s.isEmpty()) {
			continue;
		}
		if (aCtrIds[i] == ID_COMBO_JZJG) {
			fea.setInfo(layer, aFields[i], toString(atoi(s)));
		} else
			fea.setInfo(layer, aFields[i], s);
	}
	layer.save();
	dlg.show(0, 0);
	wkFile file;
	file.iniWrite(LAYER_Z + toString(nFid), "attributeDong", "1",
			getFinishPath());
	message("保存成功!");
}

string getFinishPath() {
	string s = geoset.getName();
	s.replace("\\", "/");
	s = s.left(s.reverseFind("/"));
	if (s.right(1) != "/")
		s += "/";
	s += "house.fin";
	return s;
}

void Respond(wkDialog& dlg, int ctrlId, int act) {
	if (act == wdMsgBnClicked) {
		if (ctrlId == ID_BTN_SAVE) {
			SaveValues(dlg);
		} else if (ctrlId == ID_BTN_CANSLE) {
			dlg.show(0, 0);
		}
	}
	else if (act==wdMapLbtnUp)
	{
		wkLayer layer = geoset.getLayer(LAYER_Z);
		int nCount = layer.getSelectionCount();
		if (nCount != 1) {
			return;
		}
		int nFid = layer.getSelectionAt(0).getId();
		dlg.setText(ID_EDIT_FID, toString(nFid));
	
		LoadValues(dlg);
	}
}

void CreateDlg(wkDialog& dlg) {
	dlg.create("幢属性录入", 1);
	int x = 5, y = 5, dh = 27;
	dlg.addCtrl(ID_EDIT_FID, wdCtrlText, 0, 0, 10, 10, 0, "");
	dlg.show(ID_EDIT_FID, 0);

	//y+=dh;
	dlg.addCtrl("幢号:", x, y);
	dlg.addCtrl(ID_COMBO_ZHUANGHAO, wdCtrlComboBox, x + 35, y - 1, 130, 18,
			CBS_DROPDOWN);
	int i;
	for (i = 0; i < 5; ++i) {
		dlg.insertItem(ID_COMBO_ZHUANGHAO, i, "0" + toString(i + 1));
	}

	y += dh;
	dlg.addCtrl("建筑结构:", x, y);
	dlg.addCtrl(ID_COMBO_JZJG, wdCtrlComboBox, x + 35, y - 1, 130, 18,
			CBS_DROPDOWN);
	for (i = 0; i < aJG.getSize(); ++i) {
		dlg.insertItem(ID_COMBO_JZJG, i, aJG[i]);
	}

	y += dh;
	dlg.addCtrl("总层次:", x, y);
	dlg.addCtrl(ID_EDIT_ZCC, wdCtrlEdit, x + 35, y - 1, 130, 18,
			ES_MULTILINE | ES_AUTOVSCROLL, "");

	y += dh;
	dlg.addCtrl("建成年份:", x, y);
	dlg.addCtrl(ID_EDIT_JCNF, wdCtrlEdit, x + 35, y - 1, 130, 18,
			ES_MULTILINE | ES_AUTOVSCROLL, "");

	y += dh;
	dlg.addCtrl(ID_BTN_SAVE, wdCtrlButton, x, y - 1, 75, 20, 0, "保存");
	dlg.addCtrl(ID_BTN_CANSLE, wdCtrlButton, x + 90, y - 1, 75, 20, 0, "取消");
	dlg.setAction(ID_BTN_SAVE, wdMsgBnClicked);
	dlg.setAction(ID_BTN_CANSLE, wdMsgBnClicked);
	wkLayer layer = geoset.getLayer(LAYER_Z);
	dlg.setAction(wdMapLbtnUp);
	int nFid = layer.getSelectionAt(0).getId();
	dlg.setText(ID_EDIT_FID, toString(nFid));
	
	LoadValues(dlg);
	//dlg.show(wdIdOk, 0);
	//dlg.show(wdIdCancel, 0);
	dlg.show(161, 0);
	dlg.show(162, 0);
	dlg.show();
}

void main(array args) {
	wkDialog dlg;
	CreateDlg(dlg);

	int ctrlId;
	while (1)
	{
		int act = dlg.peekAction(ctrlId);
		if (act == -1)
		{
			break;
		}

		//响应消息
		Respond(dlg, ctrlId, act);
	}
// 	wkDialog dlg;
// 	if (args.getSize() < 3) {
// 		CreateDlg(dlg);
// 	} else {
// 		dlg.from((args[args.getSize()-3])); //对话框
// 		if (dlg.handle()==0)
// 			return;
// 
// 		//callFuncByName("Respond", dlg, ctrlId, action);
// 		callFuncByName("Respond", dlg,
// 			atoi(args[args.getSize()-2]), atoi(args[args.getSize()-1]));
// 	}
}
