#include "wcDialogConstant.h"

#define ID_COMBO_LAYER_NAME			1000
#define ID_LIST_ATTRIBUTE			1001

wkGeoset geoset;
wkView view;

array m_selLayers, m_selFeas;

void Respond(wkDialog& dlg, int ctrlId, int action)
{
	if (action == wdMsgNone)
		return;
	if (action == wdMapLbtnUp)
		FillAttr(dlg);
	if (action == wdMsgSelchange && ctrlId == ID_COMBO_LAYER_NAME)
	{
		OnLayerSelChange(dlg);
	}
}
void OnLayerSelChange(wkDialog& dlg)
{
	dlg.clear(ID_LIST_ATTRIBUTE);
	if (m_selLayers.getSize() == 0)
		return;

	int nItem = dlg.getCurSel(ID_COMBO_LAYER_NAME);
	if (nItem < 0 || nItem >= m_selLayers.getSize())
		return;

	wkLayer oLayer = m_selLayers[nItem];
	wkFeature oFea = m_selFeas[nItem];
	array oFlds = oLayer.getFieldnames();
	array oVals = oFea.getInfo(oLayer, oFlds);
	for (int i = 0; i < oVals.getSize(); ++i)
	{
		dlg.insertItem(ID_LIST_ATTRIBUTE, i, oFlds[i]);

		dlg.setItemText(ID_LIST_ATTRIBUTE, i, 1, oVals[i]);
	}
}
void FillAttr(wkDialog& dlg)
{
	dlg.clear(ID_COMBO_LAYER_NAME);
	dlg.clear(ID_LIST_ATTRIBUTE);

	m_selLayers.removeAll();
	m_selFeas.removeAll();

	wkLayer oLayer;
	wkFeature oFea;
	for (int i = 0; i < geoset.getLayerCount(); ++i)
	{
		oLayer = geoset.getLayerAt(i);
		if (!oLayer.isVisiable())
			continue;
		if (oLayer.getSelectionCount())
		{
			oFea = oLayer.getSelectionAt(0);
			m_selLayers.add(oLayer);
			m_selFeas.add(oFea);		
		}
	}
	
	if (m_selFeas.getSize() == 0)
		return;

	for (i=0; i< m_selLayers.getSize(); ++i)
	{
		dlg.insertItem(ID_COMBO_LAYER_NAME,
			dlg.count(ID_COMBO_LAYER_NAME),
			m_selLayers[i].getName());
	}
	dlg.setCurSel(ID_COMBO_LAYER_NAME, 0);
}

void CreateDlg(wkDialog& dlg)
{
	dlg.create("属性");
	int x = 2, y = 2, dh = 18;
	dlg.addCtrl("图层", x, y );
	dlg.addCtrl(ID_COMBO_LAYER_NAME, wdCtrlComboBox, x+20, y , 150, 120, CBS_DROPDOWNLIST);
	dlg.setAction(ID_COMBO_LAYER_NAME, wdMsgSelchange);

	y += 20;
	dlg.addCtrl(ID_LIST_ATTRIBUTE, wdCtrlListCtrl, x, y, 170,  300, WS_VSCROLL|WS_HSCROLL|
			LVS_SINGLESEL|LVS_SHOWSELALWAYS, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES,22);
	dlg.insertColumn(ID_LIST_ATTRIBUTE, 0, "名称", LVCFMT_LEFT,90);
	dlg.insertColumn(ID_LIST_ATTRIBUTE, 1, "值", LVCFMT_LEFT, 145);
	
	FillAttr(dlg);

	dlg.setAction(wdMapLbtnUp);

	dlg.show();
	
}

void main()
{	
	wkDialog dlg;
	int ctrlId;
	CreateDlg(dlg);
	while(1)
	{			
		int act	= dlg.peekAction(ctrlId);
		if (act == -1)
			break;
		Respond(dlg, ctrlId, act);
	}
}
