/* **************************************************
	wcToolConstant.h
	wkFile 等工具类 常量表
************************************************** */
#ifndef _WC_TOOL_CONSTANT_H_
#define _WC_TOOL_CONSTANT_H_

//生成地物缓冲区
//拐角定义
#define wcJoinRound			 0 //圆角
#define wcJoinBevel			 1 //切角
#define wcJoinMiter			 2 //尖角

//端点类型
#define wcEndcapRound        0 //圆角
#define wcEndcapSquare       1 //方角
#define wcEndcapBevel        2 //平角

//	笔侧向
#define wcPenAlignCenter 0     //	（默认）居中
#define wcPenAlignLeft	 1     //	宽线绘制在中心线的左侧
#define wcPenAlignRight	 2     //	宽线绘制在中心线的右侧
#define wcPenAlignCust	 3     //	保留：自定义（沿笔宽方向的绘线间隔数组）

//对专题要素数组分级方法
#define wcReclassNature			0 // 自然分级（忽略 reclass_number 和 reclass_round）
#define wcReclassEqualInterval	1 // 等间隔
#define wcReclassEqualAccuracy	2 // 等精度（忽略 reclass_number）
#define wcReclassEqualFrequency	3 // 等频度
#define wcReclassSquareRoot		4 // sqrt
#define wcReclassSquare			5 // sqr
#define wcReclassLn				6 // ln

//------------------- wkFile ------------------------
//	fopen 的 打开模式
#define wcFileModeRead	"rt" //按读方式打开文本文件
#define wcFileModeWrite "wt" //按写方式打开文本文件

//	for findFile getMask
#define wcFileName	1
#define wcFilePath	2
#define wcFileTitle 3
#define wcFileURL	4
#define wcRoot		5
//	for findFileIs isMask
#define IsArchived	1
#define IsCompressed	2
#define IsDirectory	3
#define IsDots		4
#define IsHidden	5
#define IsNormal	6
#define IsReadOnly	7
#define IsSystem	8
#define IsTemporary	9
//	for findFileTime timeMask
#define wcCreationTime	1
#define wcLastAccessTime	2
#define wcLastWriteTime	3

//	for commPurge ---------------
#define PURGE_RXABORT 0x0002
// Terminates all outstanding overlapped read operations and returns immediately, even if the read operations have not been completed.
#define PURGE_RXCLEAR 0x0008
// Clears the input buffer (if the device driver has one).
#define PURGE_TXABORT 0x0001
// Terminates all outstanding overlapped write operations and returns immediately, even if the write operations have not been completed.
#define PURGE_TXCLEAR 0x0004
// Clears the output buffer (if the device driver has one).

// for commEscape --------------
#define CLRBREAK 9
// Restores character transmission and places the transmission line in a nonbreak state. The CLRBREAK extended function code
//	 is identical to the ClearCommBreak function.
#define CLRDTR 6
// Clears the DTR (data-terminal-ready) signal.
#define CLRRTS 4
// Clears the RTS (request-to-send) signal.
#define SETBREAK 8
// Suspends character transmission and places the transmission line in a break state until the ClearCommBreak function
//	 is called (or EscapeCommFunction is called with the CLRBREAK extended function code). The SETBREAK extended function
//	 code is identical to the SetCommBreak function. Note that this extended function does not flush data that has not been transmitted.
#define SETDTR 5
// Sends the DTR (data-terminal-ready) signal.
#define SETRTS 3
// Sends the RTS (request-to-send) signal.
#define SETXOFF 1
// Causes transmission to act as if an XOFF character has been received.
#define SETXON 2
// Causes transmission to act as if an XON character has been received.

// for commSetMask/commGetMask ------------
//	for commWaitEvent EvtMask ------------
#define EV_BREAK 0x0040
// A break was detected on input.
#define EV_CTS 0x0008
// The CTS (clear-to-send) signal changed state.
#define EV_DSR 0x0010
// The DSR (data-set-ready) signal changed state.
#define EV_ERR 0x0080
// A line-status error occurred. Line-status errors are CE_FRAME, CE_OVERRUN, and CE_RXPARITY.
#define EV_RING 0x0100
// A ring indicator was detected.
#define EV_RLSD 0x0020
// The RLSD (receive-line-signal-detect) signal changed state.
#define EV_RXCHAR 0x0001
// A character was received and placed in the input buffer.
#define EV_RXFLAG 0x0002
// The event character was received and placed in the input buffer. The event character is specified in the device's DCB structure, which is applied to a serial port by using the SetCommState function.
#define EV_TXEMPTY 0x0004
// The last character in the output buffer was sent.

//	for commClearError errors -----------
#define CE_BREAK 0x0010
// The hardware detected a break condition.
#define CE_DNS 0x0800
// Windows Me/98/95:  A parallel device is not selected. 
#define CE_FRAME 0x0008
// The hardware detected a framing error.
#define CE_IOE 0x0400
// An I/O error occurred during communications with the device.
#define CE_MODE 0x8000
// The requested mode is not supported, or the hFile parameter is invalid. If this value is specified, it is the only valid error.
#define CE_OOP 0x1000
 //Windows Me/98/95:  A parallel device signaled that it is out of paper. 
#define CE_OVERRUN 0x0002
// A character-buffer overrun has occurred. The next character is lost.
#define CE_PTO 0x0200
// Windows Me/98/95:  A time-out occurred on a parallel device. 
#define CE_RXOVER 0x0001
// An input buffer overflow has occurred. There is either no room in the input buffer, or a character was received after the end-of-file (EOF) character.
#define CE_RXPARITY 0x0004
// The hardware detected a parity error.
#define CE_TXFULL 0x0100
// The application tried to transmit a character, but the output buffer was full.

// for COMSTAT Structure array[], integer array. 数组元素的下标定义如下：
//typedef struct _COMSTAT {
#define comstat_fCtsHold 0
#define comstat_fDsrHold 1
#define comstat_fRlsdHold 2
#define comstat_fXoffHold 3
#define comstat_fXoffSent 4
#define comstat_fEof 5
#define comstat_fTxim 6
#define comstat_fReserved 7
#define comstat_cbInQue 8
#define comstat_cbOutQue 9
//} COMSTAT, 


//	for DCB array[], integer array
//typedef struct _DCB {//DWORD DCBlength;
#define dcb_BaudRate 0
#define CBR_110 110
#define CBR_300 300
#define CBR_600 600
#define CBR_1200 1200
#define CBR_2400 2400
#define CBR_4800 4800
#define CBR_9600 9600
#define CBR_14400 14400
#define CBR_19200 19200
#define CBR_38400 38400
#define CBR_57600 57600
#define CBR_115200 115200
#define CBR_128000 128000
#define CBR_256000 256000
#define dcb_fBinary 1
#define dcb_fParity 2
#define dcb_fOutxCtsFlow 3
#define dcb_fOutxDsrFlow 4
#define dcb_fDtrControl 5
#define DTR_CONTROL_DISABLE 0x00
// Disables the DTR line when the device is opened and leaves it disabled.
#define DTR_CONTROL_ENABLE 0x01
// Enables the DTR line when the device is opened and leaves it on.
#define DTR_CONTROL_HANDSHAKE 0x02
// Enables DTR handshaking. If handshaking is enabled, it is an error for the application to adjust the line
//	 by using the EscapeCommFunction function.
#define dcb_fDsrSensitivity 6
#define dcb_fTXContinueOnXoff 7
#define dcb_fOutX 8
#define dcb_fInX 9
#define dcb_fErrorChar 10
#define dcb_fNull 11
#define dcb_fRtsControl 12
#define RTS_CONTROL_DISABLE 0x00
// Disables the RTS line when the device is opened and leaves it disabled.
#define RTS_CONTROL_ENABLE 0x01
// Enables the RTS line when the device is opened and leaves it on.
#define RTS_CONTROL_HANDSHAKE 0x02
// Enables RTS handshaking. The driver raises the RTS line when the "type-ahead" (input) buffer is less than one-half
//	 full and lowers the RTS line when the buffer is more than three-quarters full. If handshaking is enabled, it is
//	 an error for the application to adjust the line by using the EscapeCommFunction function.
#define RTS_CONTROL_TOGGLE 0x03
// Specifies that the RTS line will be high if bytes are available for transmission. After all buffered bytes have
//	 been sent, the RTS line will be low.
//	Windows Me/98/95:  This value is not supported. 
#define dcb_fAbortOnError 13
#define dcb_fDummy2 14
#define dcb_wReserved 15
#define dcb_XonLim 16
#define dcb_XoffLim 17
#define dcb_ByteSize 18
#define dcb_Parity 19
#define EVENPARITY 2
// Even parity.
#define MARKPARITY 3
// Mark parity.
#define NOPARITY 0
// No parity.
#define ODDPARITY 1
// Odd parity.
#define SPACEPARITY 4
// Space parity.
#define dcb_StopBits 20
#define ONESTOPBIT 0
// 1 stop bit.
#define ONE5STOPBITS 1
// 1.5 stop bits.
#define TWOSTOPBITS 2
// 2 stop bits.
#define dcb_XonChar 21
#define dcb_XoffChar 22
#define dcb_ErrorChar 23
#define dcb_EofChar 24
#define dcb_EvtChar 25
//WORD wReserved1;} DCB, 

//---------------------------------------------------

//将几何体按指定方式op加入区域
#define wcRgnOpComplement	0 
#define wcRgnOpExclude		1 
#define wcRgnOpIntersect	2 
#define wcRgnOpUnion		3 
#define wcRgnOpXor			4 


//根据两坐标系同名点集xPoints和uPoints创建转换模型, mo	配准模型号
#define wcTransMove		1 //	1点--平移变换:--2系数
#define wcTransRotate	2 // 	2点--平移旋转(等比)变换:--4系数
#define wcTransScale	3 // 	2点--平移旋转缩放(贝尔曼托)变换:--4系数
#define wcTransAffine	4 // 	3点--仿射变换:--6系数
#define wcTransQuadrang	5 // 	4点--四边形畸变--8系数
#define wcTransQuantic2	6 // 	6点--2次方程--12系数
#define wcTransQuantic3	7 // 	10点--3次方程--20系数
#define wcTransQuantic4	8 // 	15点--4次方程--30系数
#define wcTransQuantic5	9 // 	21点--5次方程--42系数

//Dem 功能
#define wcDemMainDlg	-1 //打开功能选择对话框
#define wcDemLoad		0  //加载DEM文件生成DEM主题
#define wcDemFindDistance 1 //测定距离
#define wcDemProximityMap 2 //邻近制图
#define wcDemDensity	3 //密度功能
#define wcDemDgx2Dem	4 //由dgx生成Grid-Dem
#define wcDemDgx		5 //由DEM提取等高线
#define wcDemDgxPoint	6 //提取过点的等高线
#define wcDemSection	7 //提取一条线的DEM断面
#define wcDemSlope		8 //坡度
#define wcDemAspect	9 //坡向
#define wcDemVisual	10 //可视区
#define wcDemReclass	11 //重分类
#define wcDemLocalStat	12 //5-1 局部统计功能 Local Statistical Function
	//				2个以上的DEM主题，统计运算
#define wcDemZonal		13 //5-2 分区功能 Zonal Functions
	//				2个主题，统计运算，扩展层的属性到包含统计量
#define wcDemMapQuery	14 //6-1 选择功能 Map Query
	//				从输入的栅格主题中提取和选择出一个栅格单元的子集
#define wcDemMapCalc	15 //6-2 数学运算功能 Map Calculator
	//				对多个DEM主题的象元进行函数运算
#define wcDemNeighborStat 16 //7-1 邻域分析 Neighborhood Statistics
	//				1个DEM主题和1个矢量层（暂时为点层）
#define wcDemSaveGrdE00 17 //将DEM保存为GRD/E00
#define wcDemMessure	18 //DEM量测功能
#define wcDemThemeMan	19 //DEM主题层管理
#define wcDemImage2Dem	20 //图像输出DEM文件
#define wcDemPolygonPoint 21 //提取含点多边形
#define wcDemPolygon	22 //提取主题多边形


//对excel文件的操作
//djg 2010-05-28
//设置单元格格式
//1. 设置单元格格式化字符串
//		fmtString:
#define 		XLS_FORMAT_GENERAL		"General"
#define 		XLS_FORMAT_TEXT			"@"
#define 		XLS_FORMAT_INTEGER		"0"
#define 		XLS_FORMAT_DECIMAL		"0.00"
#define 		XLS_FORMAT_PERCENT		"0%"
#define 		XLS_FORMAT_DATE			"M/D/YY"
#define 		XLS_FORMAT_TIME			"h:mm:ss"
#define 		XLS_FORMAT_DATETIME		"M/D/YY h:mm"
//		也可以自定义，例如：需要显示三位小数则设置fmt为 "0.000"
//		注意，设置单元格格式后，excelSetCell需要设置相对应的类型值。
//		用在函数中：void excelSetCellFormatString(int row, int col, string fmtString, int sheetIndex = 0);

// 2. 设置单元格字体: option, weight, escapementType, underlineType	
//		2.1 option:
#define			EXCEL_FONT_BOLD			 0x01
#define			EXCEL_FONT_ITALIC		 0x02
#define			EXCEL_FONT_UNDERLINED	 0x04	
#define			EXCEL_FONT_STRUCK_OUT	 0x08
#define			EXCEL_FONT_OUTLINED		 0x10
#define			EXCEL_FONT_SHADOWED		 0x20
#define			EXCEL_FONT_CONDENSED	 0x40
#define			EXCEL_FONT_EXTENDED		 0x80

//		2.2 weight:
#define			EXCEL_FW_DONTCARE         0
#define			EXCEL_FW_THIN             100
#define			EXCEL_FW_EXTRALIGHT       200
#define			EXCEL_FW_LIGHT            300
#define			EXCEL_FW_NORMAL           400
#define			EXCEL_FW_MEDIUM           500
#define			EXCEL_FW_SEMIBOLD         600
#define			EXCEL_FW_BOLD             700
#define			EXCEL_FW_EXTRABOLD        800
#define			EXCEL_FW_HEAVY            900	
#define			EXCEL_FW_ULTRALIGHT       EXCEL_FW_EXTRALIGHT
#define			EXCEL_FW_REGULAR          EXCEL_FW_NORMAL
#define			EXCEL_FW_DEMIBOLD         EXCEL_FW_SEMIBOLD
#define			EXCEL_FW_ULTRABOLD        EXCEL_FW_EXTRABOLD
#define			EXCEL_FW_BLACK            EXCEL_FW_HEAVY

//		2.3	escapementType:
#define			EXCEL_ESCAPEMENT_NONE		  0
#define			EXCEL_ESCAPEMENT_SUPERSCRIPT  1
#define			EXCEL_ESCAPEMENT_SUBSCRIPT	  2
		
//		2.4	underlineType:
#define			EXCEL_UNDERLINE_NONE				0x00
#define			EXCEL_UNDERLINE_SINGLE				0x01
#define			EXCEL_UNDERLINE_DOUBLE				0x02
#define			EXCEL_UNDERLINE_SINGLE_ACCOUNTING	0x21
#define			EXCEL_UNDERLINE_DOUBLE_ACCOUNTING	0x22
//		2.5 colorIndex:
#define			EGA_BLACK	0	// 000000H
#define			EGA_WHITE	1	// FFFFFFH
#define			EGA_RED		2	// FF0000H
#define			EGA_GREEN	3	// 00FF00H
#define			EGA_BLUE	4	// 0000FFH
#define			EGA_YELLOW	5	// FFFF00H
#define			EGA_MAGENTA	6	// FF00FFH
#define			EGA_CYAN	7	// 00FFFFH
//用在函数中：void excelSetCellFont(int row, int col, string fontName="Arial", int fontOption=0, int fontHeight=200, int fontWeight=400, int fontEscapementType=0, int fontUnderlineType=0, int fontColorIndex = 0, int sheetIndex = 0);

// 3. 单元格设置
//		infoType:	1 单元格对齐, 2 转角
#define		EXCEL_CELL_SETALIGNMENT		1
#define		EXCEL_CELL_SETROTATTION		2
#define		EXCEL_CELL_SETMERGEDROWS	3
#define		EXCEL_CELL_SETMERGEDCOLS	4
//		3.1	单元格对齐alignment:
// horizontal aligmment
#define		EXCEL_HALIGN_GENERAL		 0x00
#define		EXCEL_HALIGN_LEFT			 0x01
#define		EXCEL_HALIGN_CENTRED		 0x02
#define		EXCEL_HALIGN_RIGHT			 0x03
#define		EXCEL_HALIGN_FILLED			 0x04
#define		EXCEL_HALIGN_JUSITFIED		 0x05
#define		EXCEL_HALIGN_SEL_CENTRED	 0x06
#define		EXCEL_HALIGN_DISTRIBUTED	 0x07

// vertical alignment
#define		EXCEL_VALIGN_TOP			 0x00
#define		EXCEL_VALIGN_CENTRED		 0x10
#define		EXCEL_VALIGN_BOTTOM			 0x20
#define		EXCEL_VALIGN_JUSTIFIED		 0x30
#define		EXCEL_VALIGN_DISTRIBUTED	 0x40	 
#define		EXCEL_JUSTIFY_LAST_LINE		 0x80
//用在函数中：void excelSetCellInfo(int row, int col, int infoType, int val, int sheetIndex = 0);

// Excel rows, cols
#define		EXCEL_GET_ROWCOUNT			1
#define		EXCEL_GET_COLCOUNT			2


//键盘按键
#define VK_BACK           0x08
#define VK_TAB            0x09
#define VK_CLEAR          0x0C
#define VK_RETURN         0x0D
#define VK_SHIFT          0x10
#define VK_CONTROL        0x11
#define VK_MENU           0x12
#define VK_PAUSE          0x13
#define VK_CAPITAL        0x14
#define VK_KANA           0x15
#define VK_HANGEUL        0x15  /* old name - should be here for compatibility */
#define VK_HANGUL         0x15
#define VK_JUNJA          0x17
#define VK_FINAL          0x18
#define VK_HANJA          0x19
#define VK_KANJI          0x19
#define VK_ESCAPE         0x1B
#define VK_CONVERT        0x1C
#define VK_NONCONVERT     0x1D
#define VK_ACCEPT         0x1E
#define VK_MODECHANGE     0x1F
#define VK_SPACE          0x20
#define VK_PRIOR          0x21
#define VK_NEXT           0x22
#define VK_END            0x23
#define VK_HOME           0x24
#define VK_LEFT           0x25
#define VK_UP             0x26
#define VK_RIGHT          0x27
#define VK_DOWN           0x28
#define VK_SELECT         0x29
#define VK_PRINT          0x2A
#define VK_EXECUTE        0x2B
#define VK_SNAPSHOT       0x2C
#define VK_INSERT         0x2D
#define VK_DELETE         0x2E
#define VK_HELP           0x2F
// VK_0 - VK_9 are the same as ASCII '0' - '9' (0x30 - 0x39)
// VK_A - VK_Z are the same as ASCII 'A' - 'Z' (0x41 - 0x5A)
#define VK_LWIN           0x5B
#define VK_RWIN           0x5C
#define VK_APPS           0x5D
#define VK_SLEEP          0x5F
#define VK_NUMPAD0        0x60
#define VK_NUMPAD1        0x61
#define VK_NUMPAD2        0x62
#define VK_NUMPAD3        0x63
#define VK_NUMPAD4        0x64
#define VK_NUMPAD5        0x65
#define VK_NUMPAD6        0x66
#define VK_NUMPAD7        0x67
#define VK_NUMPAD8        0x68
#define VK_NUMPAD9        0x69
#define VK_MULTIPLY       0x6A
#define VK_ADD            0x6B
#define VK_SEPARATOR      0x6C
#define VK_SUBTRACT       0x6D
#define VK_DECIMAL        0x6E
#define VK_DIVIDE         0x6F
#define VK_F1             0x70
#define VK_F2             0x71
#define VK_F3             0x72
#define VK_F4             0x73
#define VK_F5             0x74
#define VK_F6             0x75
#define VK_F7             0x76
#define VK_F8             0x77
#define VK_F9             0x78
#define VK_F10            0x79
#define VK_F11            0x7A
#define VK_F12            0x7B
#define VK_F13            0x7C
#define VK_F14            0x7D
#define VK_F15            0x7E
#define VK_F16            0x7F
#define VK_F17            0x80
#define VK_F18            0x81
#define VK_F19            0x82
#define VK_F20            0x83
#define VK_F21            0x84
#define VK_F22            0x85
#define VK_F23            0x86
#define VK_F24            0x87
#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_OEM_NEC_EQUAL  0x92   // '=' key on numpad
#define VK_OEM_FJ_JISHO   0x92   // 'Dictionary' key
#define VK_OEM_FJ_MASSHOU 0x93   // 'Unregister word' key
#define VK_OEM_FJ_TOUROKU 0x94   // 'Register word' key
#define VK_OEM_FJ_LOYA    0x95   // 'Left OYAYUBI' key
#define VK_OEM_FJ_ROYA    0x96   // 'Right OYAYUBI' key
#define VK_LSHIFT         0xA0
#define VK_RSHIFT         0xA1
#define VK_LCONTROL       0xA2
#define VK_RCONTROL       0xA3
#define VK_LMENU          0xA4
#define VK_RMENU          0xA5

#endif //_WC_TOOL_CONSTANT_H_
