/************************************************************************
  Copyright (C), 1999-2010, Zhejiang Zheda WanWei Co., Ltd.
  File name		: wkPublicFunction.cpp
  Author		: walk-djg, walk-jqj, walk-wxd     
  Version		: 1.0.0       
  Date			: 2010.9.30
  Description	: WalkScriptԶ庯, ɹ滮ݽһЩ
************************************************************************/

#ifdef _VS_WALK
#include "wkClassDefine.h"
#endif

/*;: ֶ
: 1. wkDb table: 
          2. string field: ֶ
          3. string Type : ֶ͵SQLʾ, : varchar(32), int, float
: 
  ֵ: Ƿӳɹ
  ע:   
*/
bool AddFieldToTable(wkDb db, string table, string field, string type)
{
	if(db.handle()==0)
	{
		return false;
	}

	if(db.getFieldSQLType(table, field)!=0) //ֶѴ
	{
		return true;
	}
	string sql;
	sql.format("alter table [%s] add [%s] %s", table, field, type);
	
	return db.execSQL(sql, true);
}

/*;: ֶ
: 1. wkLayer layer: 
          2. string field: ֶ
          3. string Type : ֶ͵SQLʾ, : varchar(32), int, float
: 
  ֵ: Ӻֶڲе
  ע:   
*/
int AddFieldToLayer(wkLayer layer, string field, string type)
{
	if(layer.handle()==0)
	{
		return -1;
	}
	if(layer.isDirty())
	{
		layer.save();
	}
	wkDb db=layer.getDb();
	AddFieldToTable(db, layer.getName()+"Features", field, type);
	return layer.getFieldIndex(field);
}

/*;: ɾеĲ
: 1. wkDb db: ݿ
          2. string layer: ֶ
: 
  ֵ: Ƿɹɾ
  ע:   
*/
bool DropLayer(wkDb db, string sLayer)
{
	wkGeoset geoset;

	wkLayer layer=geoset.getLayer(sLayer, db);
	if(layer.handle()!=0)
	{
		geoset.removeLayer(layer);
	}
	
	string sql;
	sql.format("drop table [%sFeatures]", sLayer);
	if (!db.execSQL(sql, true))
	{
		return false;
	}
	sql.format("drop table [%sAnnotations]", sLayer);
	if (!db.execSQL(sql, true))
	{
		return false;
	}
	sql.format("drop table [%sSymbols]", sLayer);
	if (!db.execSQL(sql, true))
	{
		return false;
	}
	sql.format("delete from [WalkLayers] where [LayerName]='%s'", sLayer);
	if(!db.execSQL(sql, true))
	{
		return false;
	}
	
	return true;
}


/*;: ڴɾе
: 1. wkLayer layer: 
:
  ֵ: Ƿɾɹ
  ע:   
*/
void DeleteLayerData(wkLayer layer)
{
	if(layer.handle()==0)
	{
		return ;
	}
	for(int i=layer.getFeatureCount(); i>=0; i--)
	{
		wkFeature feature=layer.getFeatureAt(i);
		layer.deleteFeature(feature.getId());
	}
	for(i=layer.getAnnotationCount()-1; i>=0; i--)
	{
		wkAnnotation annotation=layer.getAnnotationAt(i);
		layer.deleteAnnotation(annotation.getId());
	}
}

/*;:ݿɾе
: 1. wkLayer layer: 
:
  ֵ: 
  ע:   
*/
void EmptyLayerData(wkLayer layer)
{
	if(layer.handle()==0)
	{
		return ;
	}
	layer.empty();

	wkDb db=layer.getDb();
	string sLayer=layer.getName();

	string sql;
	sql.format("delete from [%sFeatures]", sLayer);
	db.execSQL(sql, true);
	sql.format("delete from [%sAnnotations]", sLayer);
	db.execSQL(sql, true);

	layer.load("1", "1");
}

/*;: 
: 1. wkLayer layer: 
          2. double eps: 
:
  ֵ: ĸ
  ע:   
*/
int NeatenLayer(wkLayer layer, double eps)
{
	if(layer.handle()==0)
	{
		return -1;
	}

	wkView view;
	
	string msg;
	msg.format("ڶ[%s]м...", layer.getName());
	view.waitStart(msg);
	int err=layer.neaten(eps, 1+2+4+32);//㳤++ص㴦+
	view.waitEnd();
	
	return err;
}

/*;: 㡢ߡ
: 1. wkLayer layer: 
          2. bool bPoint: Ƿ
		  3. bool bLine: Ƿ
		  4. bool bPolygon: Ƿ
:
  ֵ: ܸ
  ע:   ҵĶ㡢ߡѡм
*/
int CheckMutilGeom(wkLayer layer, bool bPoint, bool bLine, bool bPolygon)
{
	if (layer.handle()==0)
	{
		return -1;
	}

	wkView view;
	
	if(!layer.isSelectable() && !layer.isEditable())
	{
		layer.setSelectable(true);
	}
	layer.clearSelection();
	int count=0;
	
	string msg;
	msg.format("ڼ[%s]߶...", layer.getName());
	view.waitStart(msg);
	for(int i=0; i<layer.getFeatureCount(); i++)
	{
		wkFeature feature=layer.getFeatureAt(i);
		wkGeometry geom=feature.getGeometry();
		int type=geom.type();
		if(type==1) //
		{
			if(geom.getPointCount()>2 && bPoint) //
			{
				layer.addToSelection(feature);
				count++;
			}
		}
		else if(type==2) //
		{
			if(geom.getPartsCount()>1 && bLine) //
			{
				layer.addToSelection(feature);
				count++;
			}
		}
		else if(type==4) //
		{
			if(geom.getPolygonCount()>1 && bPolygon) //
			{
				layer.addToSelection(feature);
				count++;
			}
		}
		else //: 
		{
			layer.addToSelection(feature);
			count++;
		}
	}
	view.waitEnd();
	return count;
}

/*;: ԼĶ߶дɢ
: 1. wkLayer layer: 
          2. bool bPoint: Ƿ
		  3. bool bLine: Ƿ
		  4. bool bPolygon: Ƿ
		  5.bool inSelection: Ƿֻѡмв
:
  ֵ: ܸ
  ע:   ҵĶ㡢ߡѡм
*/
int ScatterMutilGeom(wkLayer layer, bool bPoint, bool bLine, bool bPolygon, bool inSelection)
{
	if (layer.handle()==0)
	{
		return -1;
	}

	int count=layer.getSelectionCount();
	if(!inSelection)
	{
		count=CheckMutilGeom(layer, bPoint, bLine, bPolygon);
	}
	if(count==0)
	{
		return 0;
	}
	int n=layer.getFieldnames().getSize(); //ֶθ

	wkView view;
	string msg;
	msg.format("ڴɢ[%s]߶...", layer.getName());
	view.waitStart(msg);
	for(int i=count-1; i>=0; i--)
	{
		view.waitMessage(msg, count-i);

		wkFeature feature=layer.getSelectionAt(i);
		wkGeometry geom=feature.getGeometry();
		int type=geom.type();

		bool bScatter=false;
		if(type==1) //
		{
			if(geom.getPointCount()>2 && bPoint) //
			{
				bScatter=true;
			}
		}
		else if(type==2) //
		{
			if(geom.getPartsCount()>1 && bLine) //
			{
				bScatter=true;
			}
		}
		else if(type==4) //
		{
			if(geom.getPolygonCount()>1 && bPolygon) //
			{
				bScatter=true;
			}
		}
		else //
		{
			bScatter=true;
		}
		if(!bScatter)
		{
			continue;
		}

		//
		array vals; vals.removeAll();
		for(int j=0; j<n; j++)
		{
			vals.add(feature.getInfo(layer, j));
		}

		//ɢ
		array geoms; geoms.removeAll(); //ɢļ
		for(j=geom.getPointCount()-1; j>=0; j--)
		{
			wkPoint pt=geom.getPointAt(j);
			wkGeometry geomPt; geomPt.create(pt);
			geoms.add(geomPt);
			geom.deletePointAt(j);
		}
		for(j=geom.getPolygonCount()-1; j>=0; j--)
		{
			wkPolygon polygon=geom.getPolygonAt(j);
			wkGeometry geomPolygon; geomPolygon.create(polygon);
			geoms.add(geomPolygon);
			geom.deletePolygonAt(j);
		}
		for(j=geom.getPartsCount()-1; j>=0; j--)
		{
			wkParts line=geom.getPartsAt(j);
			wkGeometry geomLine; geomLine.create(line, false);
			geoms.add(geomLine);
			geom.deletePartsAt(j);
		}

		//ɵ
		for(j=0; j<geoms.getSize(); j++)
		{
			wkGeometry geomNew=geoms[j];
			wkFeature feaNew=layer.addFeature(geomNew);
			geomNew.free();

			for(int k=1; k<n; k++)
			{
				feaNew.setInfo(layer, k, vals[k]);
			}
		}
		geoms.removeAll();

		//ɾԭ
		layer.clearSelection(feature);
		layer.deleteFeature(feature.getId());
		count--;
	}
	view.waitEnd();
	return count;
}

/*;: ͬص
: 1. wkLayer layer: 
          2. bool bPoint: Ƿص
		  3. bool bLIne: Ƿ
		  4. bool bPolygon: Ƿ
:
  ֵ: صĸ
  ע:   صѡм
*/
int CheckOverlap(wkLayer layer, bool bPoint, bool bLine, bool bPolygon)
{
	wkGeoset geoset;
	wkView view;

	if (layer.handle()==0)
	{
		return -1;
	}
	
	if(!layer.isSelectable() && !layer.isSelectable())
	{
		layer.setSelectable(true);
	}
	layer.clearTarget();
	
	double scale=geoset.getSystemScale();
	geoset.setSystemScale(10000.0);
	
	string msg;
	msg.format("ڼ[%s]ص...", layer.getName());
	view.waitStart(msg);
	int count=layer.getFeatureCount();
	for (int i=count-1; i>=0; i--)
	{
		wkFeature feature = layer.getFeatureAt(i);
		wkGeometry geom = feature.getGeometry();
		int nType=geom.type();
		if(nType==1 && !bPoint) continue;
		if(nType==2 && !bLine) continue;
		if(nType==4 && !bPolygon) continue;
		
		double area=geom.area();
		double perimeter=geom.perimeter();
		
		wkPoint pt=geom.centroid();
		wkBox box=geom.bounds();
		box.inflate(0.01, 0.01);
		layer.clearSelection();
		if(nType==4)
		{
			layer.searchFeature(pt);
		}
		else
		{
			layer.searchFeature(box);
		}
		for(int j=0; j<layer.getSelectionCount(); j++)
		{
			wkFeature feaFind=layer.getSelectionAt(j);
			if(feaFind.getId()==feature.getId())
			{
				continue;
			}
			
			wkGeometry geomFind=feaFind.getGeometry();
			if(geomFind.type()!=nType)
			{
				continue;
			}
			
			int n9i=geom.get9i(geomFind);
			if(n9i==2) //
			{
				if(layer.getTargetCount(feaFind)==0)
				{
					layer.addToTarget(feature);
					break;
				}
			}
			else if(n9i==4 || n9i==32) //ڴ
			{
				if(nType==4)//, ȽϴС
				{
					if(geomFind.area()-area>1e-006)
					{
						layer.addToTarget(feature);
						break;
					}
				}
				else if(nType==2)//, Ƚϳ
				{
					if(geomFind.perimeter()-perimeter>1e-006)
					{
						layer.addToTarget(feature);
						break;
					}
				}
			}
		}
	}
	view.waitEnd();
	geoset.setSystemScale(scale);
	
	layer.clearSelection();
	layer.addToSelection();
	layer.clearTarget();
	return layer.getSelectionCount();
}


/*;: ɾص
: 1. wkLayer layer: 
          2. bool bPoint: Ƿص
		  3. bool bLIne: Ƿ
		  4. bool bPolygon: Ƿ
		  5. bool inSelection: ֻѡм
:
  ֵ: δɾصĸ
  ע:   δɾصѡм
*/
int DeleteOverLap(wkLayer layer, bool bPoint, bool bLine, bool bPolygon, bool inSelection)
{
	wkGeoset geoset;
	wkView view;

	if (layer.handle()==0)
	{
		return -1;
	}

	int count=layer.getSelectionCount();
	if(!inSelection)
	{
		count=CheckOverlap(layer, bPoint, bLine, bPolygon); //Ҳѡ
	}
	if(count==0)
	{
		return 0;
	}

	if(!layer.isSelectable() && !layer.isSelectable())
	{
		layer.setSelectable(true);
	}
	
	layer.clearTarget();
	layer.addToTarget();
	layer.clearSelection();

	double scale=geoset.getSystemScale();
	geoset.setSystemScale(10000.0);

	view.waitStart("");
	
	string msg;
	count=layer.getTargetCount();
	msg.format("ɾ[%s]ص..., %d -", layer.getName(), count);
	for (int i=count-1; i>=0; i--)
	{
		view.waitMessage(msg, count-i);
		
		wkFeature feature = layer.getTargetAt(i);
		wkGeometry geom = feature.getGeometry();
		int nType=geom.type();
		if(nType==1 && !bPoint) continue;
		if(nType==2 && !bLine) continue;
		if(nType==4 && !bPolygon) continue;

		double area=geom.area();
		double perimeter=geom.perimeter();
		
		wkPoint pt=geom.centroid();
		wkBox box=geom.bounds();
		box.inflate(0.01, 0.01);
		layer.clearSelection();
		if(nType==4)
		{
			layer.searchFeature(pt);
		}
		else
		{
			layer.searchFeature(box);
		}
		for(int j=0; j<layer.getSelectionCount(); j++)
		{
			wkFeature feaFind=layer.getSelectionAt(j);
			if(feaFind.getId()==feature.getId())
			{
				continue;
			}
			
			wkGeometry geomFind=feaFind.getGeometry();
			if(geomFind.type()!=nType)
			{
				continue;
			}
			
			int n9i=geom.get9i(geomFind);
			if(n9i==2) //
			{
				layer.clearTarget(feature);
				layer.deleteFeature(feature.getId());
				break;
			}
			else if(n9i==4 || n9i==32) //ڴ
			{
				if(nType==4)//, ȽϴС
				{
					if(geomFind.area()-area>0.00000001)
					{
						layer.clearTarget(feature);
						layer.deleteFeature(feature.getId());
						break;
					}
				}
				else if(nType==2)//, Ƚϳ
				{
					if(geomFind.perimeter()-perimeter>0.00000001)
					{
						layer.clearTarget(feature);
						layer.deleteFeature(feature.getId());
						break;
					}
				}
			}
		}
	}
	view.waitEnd();
	geoset.setSystemScale(scale);
	
	layer.clearSelection();
	layer.addToSelection();
	layer.clearTarget();
	return layer.getSelectionCount();
}

/*;: ͬص()
: 1. wkLayer layer: 
          2. bool bPoint: Ƿص
		  3. bool bLIne: Ƿ
		  4. bool bPolygon: Ƿ
		  5. bool bCode: صʱǷǴ
		  6.string CodeField ֶ
		  7. bool bAngle: صʱǷǽǶ
		  8.string AngleField Ƕֶ
:
  ֵ: صĸ
  ע:   صѡм
*/
int CheckOverlapFJ(wkLayer layer, bool bPoint, bool bLine, bool bPolygon,bool bCode,string CodeField ,bool bAngle,string AngleField)
{
	wkGeoset geoset;
	wkView view;

	if (layer.handle()==0)
	{
		return -1;
	}
	
	if(!layer.isSelectable() && !layer.isSelectable())
	{
		layer.setSelectable(true);
	}
	layer.clearTarget();
	
	double scale=geoset.getSystemScale();
	geoset.setSystemScale(10000.0);
	
	string msg;
	msg.format("ڼ[%s]ص...", layer.getName());
	view.waitStart(msg);
	string strCode,strAngle;
	layer.loadInfo(true);
	int fieldIndexCode=layer.getFieldIndex(CodeField);
	int fieldIndexAngle=layer.getFieldIndex(AngleField);
	int count=layer.getFeatureCount();
	for (int i=count-1; i>=0; i--)
	{
		wkFeature feature = layer.getFeatureAt(i);
		wkGeometry geom = feature.getGeometry();
		int nType=geom.type();
		if(nType==1 && !bPoint) continue;
		if(nType==2 && !bLine) continue;
		if(nType==4 && !bPolygon) continue;
		if(bCode)
		{
			strCode=feature.getInfo(layer,fieldIndexCode);
		}
		if(bAngle)
		{
			strAngle=feature.getInfo(layer,fieldIndexAngle);
		}
		
		
		double area=geom.area();
		double perimeter=geom.perimeter();
		
		wkPoint pt=geom.centroid();
		wkBox box=geom.bounds();
		box.inflate(0.01, 0.01);
		layer.clearSelection();
		if(nType==4)
		{
			layer.searchFeature(pt);
		}
		else
		{
			layer.searchFeature(box);
		}
		for(int j=0; j<layer.getSelectionCount(); j++)
		{
			wkFeature feaFind=layer.getSelectionAt(j);
			if(feaFind.getId()==feature.getId())
			{
				continue;
			}
			
			wkGeometry geomFind=feaFind.getGeometry();
			if(geomFind.type()!=nType)
			{
				continue;
			}
			
			int n9i=geom.get9i(geomFind);
			if(n9i==2) //
			{
				if(layer.getTargetCount(feaFind)==0)
				{
					if(bCode)
					{
						string strCodeFind=feaFind.getInfo(layer,fieldIndexCode);
						if(strCodeFind.compareNoCase(strCode)!=0)
							continue;
					}
					if(bAngle)
					{
						string strAngleFind=feaFind.getInfo(layer,fieldIndexAngle);
						if(abs(atof(strAngleFind)-atof(strAngle))>0.01)
							continue;
					}
					layer.addToTarget(feature);
					break;
				}
			}
			else if(n9i==4 || n9i==32) //ڴ
			{
				if(nType==4)//, ȽϴС
				{
					if(geomFind.area()-area>1e-006)
					{
						if(bCode)
						{
							string strCodeFind=feaFind.getInfo(layer,fieldIndexCode);
							if(strCodeFind.compareNoCase(strCode)!=0)
								continue;
						}
						if(bAngle)
						{
							string strAngleFind=feaFind.getInfo(layer,fieldIndexAngle);
							if(abs(atof(strAngleFind)-atof(strAngle))>0.01)
								continue;
						}
						layer.addToTarget(feature);
						break;
					}
				}
				else if(nType==2)//, Ƚϳ
				{
					if(geomFind.perimeter()-perimeter>1e-006)
					{
						if(bCode)
						{
							string strCodeFind=feaFind.getInfo(layer,fieldIndexCode);
							if(strCodeFind.compareNoCase(strCode)!=0)
								continue;
						}
						if(bAngle)
						{
							string strAngleFind=feaFind.getInfo(layer,fieldIndexAngle);
							if(abs(atof(strAngleFind)-atof(strAngle))>0.01)
								continue;
						}
						layer.addToTarget(feature);
						break;
					}
				}
			}
		}
	}
	view.waitEnd();
	layer.loadInfo(false);
	geoset.setSystemScale(scale);
	
	layer.clearSelection();
	layer.addToSelection();
	layer.clearTarget();
	return layer.getSelectionCount();
}


/*;: ɾص)
: 1. wkLayer layer: 
          2. bool bPoint: Ƿص
		  3. bool bLIne: Ƿ
		  4. bool bPolygon: Ƿ
		  5. bool bCode: صʱǷǴ
		  6.string CodeField ֶ
		  7. bool bAngle: صʱǷǽǶ
		  8.string AngleField Ƕֶ
		  9. bool inSelection: ֻѡм
:
  ֵ: δɾصĸ
  ע:   δɾصѡм
*/
int DeleteOverLapFJ(wkLayer layer, bool bPoint, bool bLine, bool bPolygon, bool bCode,string CodeField ,bool bAngle,string AngleField,bool inSelection)
{
	wkGeoset geoset;
	wkView view;

	if (layer.handle()==0)
	{
		return -1;
	}

	int count=layer.getSelectionCount();
	if(!inSelection)
	{
		count=CheckOverlapFJ(layer, bPoint, bLine, bPolygon,bCode,CodeField,bAngle,AngleField); //Ҳѡ
	}
	if(count==0)
	{
		return 0;
	}

	if(!layer.isSelectable() && !layer.isSelectable())
	{
		layer.setSelectable(true);
	}
	
	layer.clearTarget();
	layer.addToTarget();
	layer.clearSelection();

	double scale=geoset.getSystemScale();
	geoset.setSystemScale(10000.0);

	view.waitStart("");
	
	string msg;
	count=layer.getTargetCount();
	msg.format("ɾ[%s]ص..., %d -", layer.getName(), count);
	for (int i=count-1; i>=0; i--)
	{
		view.waitMessage(msg, count-i);
		
		wkFeature feature = layer.getTargetAt(i);
		wkGeometry geom = feature.getGeometry();
		int nType=geom.type();
		if(nType==1 && !bPoint) continue;
		if(nType==2 && !bLine) continue;
		if(nType==4 && !bPolygon) continue;

		double area=geom.area();
		double perimeter=geom.perimeter();
		
		wkPoint pt=geom.centroid();
		wkBox box=geom.bounds();
		box.inflate(0.01, 0.01);
		layer.clearSelection();
		if(nType==4)
		{
			layer.searchFeature(pt);
		}
		else
		{
			layer.searchFeature(box);
		}
		for(int j=0; j<layer.getSelectionCount(); j++)
		{
			wkFeature feaFind=layer.getSelectionAt(j);
			if(feaFind.getId()==feature.getId())
			{
				continue;
			}
			
			wkGeometry geomFind=feaFind.getGeometry();
			if(geomFind.type()!=nType)
			{
				continue;
			}
			
			int n9i=geom.get9i(geomFind);
			if(n9i==2) //
			{
				layer.clearTarget(feature);
				layer.deleteFeature(feature.getId());
				break;
			}
			else if(n9i==4 || n9i==32) //ڴ
			{
				if(nType==4)//, ȽϴС
				{
					if(geomFind.area()-area>0.00000001)
					{
						layer.clearTarget(feature);
						layer.deleteFeature(feature.getId());
						break;
					}
				}
				else if(nType==2)//, Ƚϳ
				{
					if(geomFind.perimeter()-perimeter>0.00000001)
					{
						layer.clearTarget(feature);
						layer.deleteFeature(feature.getId());
						break;
					}
				}
			}
		}
	}
	view.waitEnd();
	geoset.setSystemScale(scale);
	
	layer.clearSelection();
	layer.addToSelection();
	layer.clearTarget();
	return layer.getSelectionCount();
}
/*;: ཻͬ
: 1. wkLayer layer: 
:
  ֵ: ཻλø
  ע:   ཻλü롰ʷּ㡱ѡ
*/
int CheckIntersect(wkLayer layer)
{
	wkGeoset geoset;
	wkView view;

	if(layer.handle()==0)
	{
		return -1;
	}
	wkDb db=layer.getDb();
	string sLayerResult="ʷּ";
	if(!db.isLayerExisted(sLayerResult))
	{
		if(!db.createLayer(sLayerResult))
		{
			return -1;
		}
	}
	wkLayer layerResult=geoset.addLayer(sLayerResult, db);
	if(layerResult.handle()==0)
	{
		return -1;
	}
	if(!layerResult.isSelectable() && !layerResult.isEditable())
	{
		layerResult.setSelectable(true);
	}
	layerResult.empty();
	
	double scale=geoset.getSystemScale();
	geoset.setSystemScale(10000.0);
	
	string msg;
	msg.format("ڶ[%s]ཻ...", layer.getName());
	view.waitStart(msg);
	for(int i=0; i<layer.getFeatureCount(); i++)
	{
		wkFeature feature=layer.getFeatureAt(i);
		wkGeometry geom=feature.getGeometry();
		if(geom.type()!=4)
		{
			continue;
		}

		layer.clearSelection();
		layer.searchFeature(geom, 8); //ཻ
		for(int j=0; j<layer.getSelectionCount(); j++)
		{
			wkFeature feaFind=layer.getSelectionAt(j);
			wkGeometry geomFind=feaFind.getGeometry();
			if(geomFind.type()!=4)
			{
				continue;
			}
			wkGeometry geomIntersect=geom.boolOp(geomFind, 0); //
			if(geomIntersect.handle()!=0 && geomIntersect.type()==4)
			{
				geomIntersect.putInOrder();
				layerResult.clearSelection();
				if(layerResult.searchFeature(geomIntersect, 2)==0)
				{
					layerResult.addFeature(geomIntersect);
				}
			}
			geomIntersect.free();
		}	
	}
	view.waitEnd();

	layer.clearSelection();
	geoset.setSystemScale(scale);

	layerResult.clearSelection();
	for(i=0; i<layerResult.getFeatureCount(); i++)
	{
		layerResult.addToSelection(layerResult.getFeatureAt(i));
	}

	return layerResult.getSelectionCount();
}

/*;: ȡ
: 1. wkLayer layer: 
          2. wkFeature feature: 
          3. array indexs: ֶ
:
  ֵ: 
  ע:   
*/
array GetFeatureInfo(wkLayer layer, wkFeature feature, array indexs, bool bTrim, bool bMakeUpper)
{
	array vals; vals.removeAll();
	for(int i=0; i<indexs.getSize(); i++)
	{
		int index=indexs[i];
		string val=feature.getInfo(layer, index);
		if(bTrim)
		{
			val.trimLeft();
			val.trimRight();
		}
		if(bMakeUpper)
		{
			val.makeUpper();
		}
		vals.add(val);
	}
	return vals;
}

/*;: ͼ
: 1. wkLayer layer: 
          2. double fSmallArea: ͼС
:
  ֵ: ͼ߸
  ע:   ѡͼ
*/
int CheckSmallArea(wkLayer layer, double fSmallArea)
{
	wkView view;

	if(layer.handle()==0)
	{
		return -1;
	}
	string sLayer=layer.getName();
	layer.setEditable(true);
	layer.clearSelection();

	string msg;
	msg.format("ͳ[%s]С%.1fƽ׵...", sLayer, fSmallArea);
	view.waitStart(msg);
	array smalls; smalls.removeAll(); //¼
	for(int i=0; i<layer.getFeatureCount(); i++)
	{
		wkFeature feature=layer.getFeatureAt(i);
		wkGeometry geom=feature.getGeometry();
		if(geom.type()==4 && geom.area()<fSmallArea)
		{
			layer.addToSelection(feature);
		}
	}
	view.waitEnd();
	return layer.getSelectionCount();
}

/*;: ϲͼ
: 1. wkLayer layer: 
          2. double fSmallArea: ͼС
          3. array fields: οֶ, ֵֶȲŻϲ
          4. bool bLength: Ƿ빲ϳͼߺϲ, true-빲ϳͼߺϲ
		                                             false-ϴͼߺϲ
		  5. bool bInselection: ֻѡмеͼ߽кϲ
:
  ֵ: δϲĸ
  ע:   
*/
int UnionSmallArea(wkLayer layer, double fSmallArea, array fields, bool bLength, bool bInSelection)
{
	wkGeoset geoset;
	wkView view;

	if(layer.handle()==0)
	{
		return -1;
	}
	string sLayer=layer.getName();

	string msg;
	array indexs; indexs.removeAll();
	for(int i=0; i<fields.getSize(); i++)
	{
		int nIndex=layer.getFieldIndex(fields[i]);
		if(nIndex==-1)
		{
			msg.format("ֶ[%s][%s]", fields[i], sLayer);
			message(msg);
			return -1;
		}
		indexs.add(nIndex);
	}

	int count=layer.getSelectionCount();
	if(!bInSelection)
	{
		count=CheckSmallArea(layer, fSmallArea);
	}
	if(count==0)
	{
		return 0;
	}

	array smalls; smalls.removeAll(); //¼Id
	for(i=0; i<layer.getSelectionCount(); i++) //水ӴС, ֤СȺϲ
	{
		wkFeature feaSel=layer.getSelectionAt(i);
		wkGeometry geomSel=feaSel.getGeometry();
		double areaSel=geomSel.area();
		int at=0;
		for(int j=0; j<smalls.getSize(); j++)
		{
			wkFeature feaSmall=layer.getFeature(smalls[j]);
			wkGeometry geomSmall=feaSmall.getGeometry();
			if(areaSel>geomSmall.area())
			{
				at=j;
				break;
			}
		}
		smalls.insertAt(at, feaSel.getId());
	}

	//ߣ ߺϲ
	double scale=geoset.getSystemScale();
	geoset.setSystemScale(1.0);

	layer.clearTarget(); //Ŀ¼仯

	view.waitStart("׼...");
	layer.loadInfo(true);

	count=smalls.getSize();
	msg.format("ںϲ[%s](<%.1f)..., %d -", sLayer, fSmallArea, count);
	for(i=count-1; i>=0; i--)
	{
		view.waitMessage(msg, count-i);

		wkFeature feaSmall=layer.getFeature(smalls[i]);
		wkGeometry geomSmall=feaSmall.getGeometry();
		if(geomSmall.area()>fSmallArea) //ϲ>fSmallArea
		{
			smalls.removeAt(i);
			continue;
		}
		array infoSmall=GetFeatureInfo(layer, feaSmall, indexs, true, true);

		int nIdBig=0; //ʺϺϲĵ
		double fMax=0.001; //: 糤Ȼ
		layer.clearSelection();
		layer.searchFeature(geomSmall, 8+64); //ཻ+ⴥ
		for(int j=0; j<layer.getSelectionCount(); j++)
		{
			wkFeature feaTouch=layer.getSelectionAt(j); //ڵ
			wkGeometry geomTouch=feaTouch.getGeometry();
			if(geomTouch.type()!=4)
			{
				continue;
			}
			array infoTouch=GetFeatureInfo(layer, feaTouch, indexs, true, true);
			if(infoTouch!=infoSmall) //Բ, ų
			{
				continue;
			}
			double fBound=geomTouch.area();
			if(bLength)
			{
				wkGeometry geomUnion=geomTouch.boolOp(geomSmall, 1);
				geomUnion.putInOrder();
				fBound=geomTouch.perimeter()+geomSmall.perimeter()-geomUnion.perimeter(); //߳
				geomUnion.free();
			}
			//ݹ߳õʺϺϲĵ
			if(fMax<fBound)
			{
				fMax=fBound;
				nIdBig=feaTouch.getId();
			}
		}
		
		if(nIdBig>0) //ҵʵ
		{
			wkFeature feaBig=layer.getFeature(nIdBig);
			wkGeometry geomBig=feaBig.getGeometry();
			wkGeometry geomNew=geomBig.boolOp(geomSmall, 1); //ϲ
			if(geomNew.type()==4 && geomNew.getPolygonCount()==1)
			{
				geomNew.putInOrder();
				feaBig.setGeometry(geomNew); //¼
				layer.reindex(feaBig);
				layer.addToTarget(feaBig); //ϲĵӵĿ꼯
				layer.deleteFeature(feaSmall.getId()); //ɾ
				smalls.removeAt(i); 
			}
			geomNew.free();
		}
	}
	layer.loadInfo(false);
	view.waitEnd();

	if(layer.getTargetCount()>0)
	{
		layer.clearSelection();
		layer.addToSelection(); //Targetӵselection
		layer.clearTarget();

		wkClean cln;
		cln.build(layer, true, layer, 0.001);//ԸĶй鿿, ҵ
	}

	//ָϵͳ
	geoset.setSystemScale(scale);

	//ʣδϲѡ
	layer.clearSelection();
	for(i=0; i<smalls.getSize(); i++)
	{
		wkFeature feaSel=layer.getFeature(smalls[i]);
		if(feaSel.handle()!=0)
		{
			layer.addToSelection(feaSel);
		}
	}
	return layer.getSelectionCount();
}

/*;: ͼ㰴Ժϲ, ʺʷֵͼ(鹹)
: 1. wkLayer layer: 
          2. fields: οֶ, ֵֶȲŻϲ
          3. double: eps: ϲ޲
:
  ֵ: Ƿϲɹ
  ע:   
*/
bool UnionLayerGroup(wkLayer layer, array fields, double eps)
{
	wkGeoset geoset;
	wkView view;

	if(layer.handle()==0 || fields.getSize()==0)
	{
		return false;
	}

	for(int i=0; i<fields.getSize(); i++)
	{
		int nIndex=layer.getFieldIndex(fields[i]);
		if(nIndex==-1)
		{
			return false;
		}
	}
	int n=layer.getFieldnames().getSize(); //ֶܸ
	if(layer.isDirty())
	{
		layer.save();
	}
	string sLayer=layer.getName();
	wkDb db=layer.getDb();

	//һʱ, 
	i=1;
	string sLayerTemp="TempLayer";
	while(db.isLayerExisted(sLayerTemp))	//õЧʱ
	{
		sLayerTemp="TempLayer_" + toString(i++);
	}
	if(!db.createLayer(sLayerTemp, sLayer, true))
	{
		return false;
	}

	//ʱֶαֶκϲֵ
	i=1;
	string sFldTemp="TempField";
	while(db.getFieldSQLType(sLayerTemp + "Features", sFldTemp)!=0) //õЧʱֶ
	{
		sFldTemp="TempField_" + toString(i++);
	}
	string sql;
	sql.format("alter table [%sFeatures] add [%s] varchar(255)", sLayerTemp, sFldTemp);
	if(!db.execSQL(sql, true))
	{
		return false;
	}
	
	//ֶκϲʱֶ
	string sSet="";
	for(i=0; i<fields.getSize(); i++)
	{
		//string sField="trim(" + fields[i] + ")";  //ȥո
		string sField;
		sField.format("trim(%s)", fields[i]);
		if(!sSet.isEmpty())
		{
			sSet+=" & '_' & ";
		}
		sSet+=sField;
	}
	sql.format("update [%sFeatures] set [%s]=%s", sLayerTemp, sFldTemp, sSet);
	if(!db.execSQL(sql, true))
	{
		return false;
	}
	wkLayer layerTemp=geoset.addLayer(sLayerTemp, db); //
	if(layerTemp.handle()==0)
	{
		return false;
	}
	int nIndexTemp=layerTemp.getFieldIndex(sFldTemp);

	//ղ, ׼д
	layer.empty();
	sql.format("delete from [%sFeatures]", sLayer);
	if(!db.execSQL(sql, true))
	{
		return false;
	}
	layer.load("1", "1");

	sql.format("select [%s] from [%sFeatures] group by [%s]", sFldTemp, sLayerTemp, sFldTemp);
	array groups; groups.removeAll();
	groups=db.getDataBySQL(sql, 1000000);

	view.waitStart("");
	string msg;
	msg.format("ںϲ[%s]..., %d -", sLayer, groups.getSize());
	for(i=0; i<groups.getSize(); i++)
	{
		view.waitMessage(msg, i+1);

		wkClean cln;
		cln.create(layerTemp.getBox());

		string sFilter;
		sFilter.format("%s = '%s'", sFldTemp, groups[i]);
		layerTemp.clearSelection();
		layerTemp.searchFeature(sFilter);
		for(int j=0; j<layerTemp.getSelectionCount(); j++)
		{
			wkFeature feaTemp=layerTemp.getSelectionAt(j);
			wkGeometry geomTemp=feaTemp.getGeometry();
			if(geomTemp.type()!=4)
			{
				continue;
			}
			for(int k=0; k<geomTemp.getPartsCount(); k++)
			{
				wkParts parts=geomTemp.getPartsAt(k);
				cln.xorOverLine(parts, eps);
			}
		}

		layerTemp.clearTarget();
		layerTemp.addToTarget(); //ηѡмĿ꼯

		//ϲ
		cln.cleanZero(eps);
		cln.build(eps);
		for (j=0; j<cln.getPolygonCount()-1; j++)
		{
		 	wkGeometry polygon=cln.getPolygonAt(j);
			wkPoint pt=polygon.centroid();

			layerTemp.clearSelection();
			if(layerTemp.searchFeature(pt)>0)
			{
				wkFeature feaFind=layerTemp.getSelectionAt(0);
				if(layerTemp.getTargetCount(feaFind)>0)
				{
					layer.addFeature(polygon);
				}
			}
		 	polygon.free();
 		}
		cln.freeBuild();
		layerTemp.clearTarget();
	}

	//	
	int count=layer.getFeatureCount();
	layerTemp.loadInfo(true);
	layer.loadInfo(true);
	msg.format("[%s]д..., %d -", sLayer, count);
	for(i=count; i>=0; i--)
	{
		view.waitMessage(msg, count-i);

		wkFeature feature=layer.getFeatureAt(i);
		wkGeometry geom=feature.getGeometry();
		wkPoint pt=geom.centroid();
		
		layerTemp.clearSelection();
		if(layerTemp.searchFeature(pt)==0)
		{
			layer.deleteFeature(feature.getId());
			continue;
		}

		wkFeature feaTemp=layerTemp.getSelectionAt(0); //
		for(int j=1; j<n; j++)
		{
			string val=feaTemp.getInfo(layerTemp, j);
			feature.setInfo(layer, j, val);
		}
	}
	layerTemp.loadInfo(false);
	layer.loadInfo(false);
	view.waitEnd();

	layer.save();

	//ɾʱ
	DropLayer(layerTemp.getDb(), sLayerTemp);

	return true;
}

/*;: ͼ㰴Ժϲ, ʺʷֵͼ(幹), wkCleanĿɿ
: 1. wkLayer layer: 
          2. fields: οֶ, ֵֶȲŻϲ
          3. double: eps: ϲ޲
:
  ֵ: Ƿϲɹ
  ע:   
*/
bool UnionLayerClean(wkLayer layer, array fields, double eps)
{
	wkGeoset geoset;
	wkView view;

	if(layer.handle()==0 || fields.getSize()==0)
	{
		return false;
	}

	for(int i=0; i<fields.getSize(); i++)
	{
		int nIndex=layer.getFieldIndex(fields[i]);
		if(nIndex==-1)
		{
			return false;
		}
	}
	if(layer.isDirty())
	{
		layer.save();
	}
	int n=layer.getFieldnames().getSize(); //ֶܸ
	string sLayer=layer.getName();
	wkDb db=layer.getDb();

	//һʱ, 
	i=1;
	string sLayerTemp="TempLayer";
	while(db.isLayerExisted(sLayerTemp))	//õЧʱ
	{
		sLayerTemp="TempLayer_" + toString(i++);
	}
	if(!db.createLayer(sLayerTemp, sLayer, true)) //ݵʱ
	{
		return false;
	}

	//ʱֶαֶκϲֵ
	i=1;
	string sFldTemp="TempField";
	while(db.getFieldSQLType(sLayerTemp + "Features", sFldTemp)!=0) //õЧʱֶ
	{
		sFldTemp="TempField_" + toString(i++);
	}
	string sql;
	sql.format("alter table [%sFeatures] add [%s] varchar(255)", sLayerTemp, sFldTemp);
	if(!db.execSQL(sql, true))
	{
		return false;
	}
	
	//ֶκϲʱֶ
	string sSet="";
	for(i=0; i<fields.getSize(); i++)
	{
		string sField;
		sField.format("trim(%s)", fields[i]);
		if(!sSet.isEmpty())
		{
			sSet+=" & '_' & ";
		}
		sSet+=sField;
	}
	sql.format("update [%sFeatures] set [%s]=%s", sLayerTemp, sFldTemp, sSet);
	if(!db.execSQL(sql, true))
	{
		return false;
	}
	wkLayer layerTemp=geoset.addLayer(sLayerTemp, db); //
	if(layerTemp.handle()==0)
	{
		return false;
	}
	int nIndexTemp=layerTemp.getFieldIndex(sFldTemp);

	//ղ, ׼д
	EmptyLayerData(layer);

	sql.format("select [%s] from [%sFeatures] group by [%s]", sFldTemp, sLayerTemp, sFldTemp);
	array groups; groups.removeAll();
	groups=db.getDataBySQL(sql, 1000000);

	view.waitStart("");
	string msg;
	msg.format("ںϲ[%s]..., %d -", sLayer, groups.getSize());
	for(i=0; i<groups.getSize(); i++)
	{
		view.waitMessage(msg, i+1);

		wkClean cln;
		cln.create(layerTemp.getBox());

		string sFilter;
		sFilter.format("%s = '%s'", sFldTemp, groups[i]);
		layerTemp.clearSelection();
		layerTemp.searchFeature(sFilter);
		for(int j=0; j<layerTemp.getSelectionCount(); j++)
		{
			wkFeature feaTemp=layerTemp.getSelectionAt(j);
			wkGeometry geomTemp=feaTemp.getGeometry();
			if(geomTemp.handle()==0 || geomTemp.type()!=4)
			{
				continue;
			}
			for(int k=0; k<geomTemp.getPartsCount(); k++)
			{
				wkParts parts=geomTemp.getPartsAt(k);
				cln.xorOverLine(parts, eps);
			}
		}

		cln.combineToArc(); //ϳɻμ
		for(wkParts arc=cln.getFirstArc(); arc.handle()!=0; arc=cln.getNextArc())
		{
			layer.addFeature(arc, false);
			arc.free();
		}
		cln.free();
	}
	
	//
	layer.setEditable(true);
	array layers; layers.add(layer);
	wkClean bd;
	bd.build(layers, false, 1e-006);

	//	
	int count=layer.getFeatureCount();
	layerTemp.loadInfo(true);
	layer.loadInfo(true);
	msg.format("[%s]д..., %d -", sLayer, count);
	for(i=count-1; i>=0; i--)
	{
		view.waitMessage(msg, count-i);

		wkFeature feature=layer.getFeatureAt(i);
		wkGeometry geom=feature.getGeometry();
		if(geom.type()!=4)
		{
			layer.deleteFeature(feature.getId());
			continue;
		}

		wkPoint pt=geom.centroid();
		
		layerTemp.clearSelection();
		if(layerTemp.searchFeature(pt)==0)
		{
			layer.deleteFeature(feature.getId());
			continue;
		}

		wkFeature feaTemp=layerTemp.getSelectionAt(0); //
		for(int j=1; j<n; j++)
		{
			string val=feaTemp.getInfo(layerTemp, j);
			feature.setInfo(layer, j, val);
		}
	}
	layerTemp.loadInfo(false);
	layer.loadInfo(false);
	view.waitEnd();

	layer.save();

	//ɾʱ
	DropLayer(db, sLayerTemp);

	return true;
}

/*;: ͼ㰴Ժϲ, ʺϲʷֵͼ(ϲ)
: 1. wkLayer layer: 
          2. fields: οֶ, ֵֶȲŻϲ
		  3. double: eps: ϲ޲
:
  ֵ: Ƿϲɹ
  ע:   
*/
bool UnionLayerOp(wkLayer layer, array fields, double eps)
{
	wkGeoset geoset;
	wkView view;

	if(layer.handle()==0 || fields.getSize()==0)
	{
		return false;
	}

	array indexs; indexs.removeAll();
	for(int i=0; i<fields.getSize(); i++)
	{
		int nIndex=layer.getFieldIndex(fields[i]);
		if(nIndex==-1)
		{
			return false;
		}
		indexs.add(nIndex);
	}
	int n=layer.getFieldnames().getSize(); //ֶܸ
	
	//ϵͳ, ߺϲľ
	double scale=geoset.getSystemScale();
	geoset.setSystemScale(1.0);	
	
	string msg;
	msg.format("׼[%s]...", layer.getName());
	view.waitStart(msg);

	layer.loadInfo(true);
	
	int count=layer.getFeatureCount();
	msg.format("ںϲ[%s]..., %d -", layer.getName(), count);
	int clockPreSec;
	int start=clock(clockPreSec);
	for(i=count-1; i>=0; i--)
	{
		int end=clock();
		if(end-start>clockPreSec)
		{
			view.waitMessage(msg, count-i);
			start=end;
		}
		
		wkFeature featrue=layer.getFeatureAt(i);
		wkGeometry geom=featrue.getGeometry();
		if(geom.type()!=4)
		{
			continue;
		}
		double fArea=geom.area();

		array vals; vals.removeAll(); //¼featureĺϲ
		for(int j=0; j<indexs.getSize(); j++)
		{
			string val=featrue.getInfo(layer, indexs[j]); val.makeUpper();
			val.trimRight(); val.trimLeft();
			vals.add(val);
		}

		wkBox box=geom.bounds();
		layer.clearSelection();
		layer.searchFeature(box);
		for(j=0; j<layer.getSelectionCount(); j++)
		{
			wkFeature feaFind=layer.getSelectionAt(j);
			if(feaFind.getId()==featrue.getId())
			{
				continue;
			}
			wkGeometry geomFind=feaFind.getGeometry();
			if(geomFind.type()!=4)
			{
				continue;
			}
			double fAreaFind=geomFind.area();

			array attrs; attrs.removeAll(); //¼feaFindĺϲ
			for(int k=0; k<indexs.getSize(); k++)
			{
				string attr=feaFind.getInfo(layer, indexs[k]); attr.makeUpper();
				attr.trimRight(); attr.trimLeft();
				attrs.add(attr);
			}
			if(attrs!=vals)
			{
				continue;
			}

			int r8bool, lineTouch, pointTouch;
			int n9i=geom.get9i(geomFind, r8bool, lineTouch, pointTouch);
			if(n9i==1) //޹
			{
				continue;
			}
			if(n9i==64 && lineTouch==0) //ⴥΪ㴥
			{
				continue;
			}

			wkGeometry geomNew=geomFind.boolOp(geom, 1); //ϲ
			geomNew.putInOrder();
			if(geomNew.getPolygonCount()!=1) 
			{
				geomNew.free();
				continue;
			}

			feaFind.setGeometry(geomNew, layer);
			layer.reindex(feaFind);
			geomNew.free();
			if(fAreaFind<fArea) //̳д
			{
				for(k=1; k<n; k++)
				{
					string s=featrue.getInfo(layer, k);
					feaFind.setInfo(layer, k, s);
				}
			}
			layer.deleteFeature(featrue.getId());
			break;					
		}
	}
	layer.loadInfo(false);
	view.waitEnd();

	//ָϵͳ
	geoset.setSystemScale(scale);
	
	wkClean cln;
	cln.build(layer, false, layer, eps); //鿿ҵ㴦, ռʱ

	return true;
}

/*;: ͼӲϵ, ʹClean
: 1. array srcLayers: ӵԴ
          2. wkLayer layer: Ӻ󱣴ͼ
		  3. array idFields: ʶֶ, ¼ӺԴFeatureID, Դһ
		  4. double eps: Ӿ
:
  ֵ: Ƿӳɹ
  ע:   
*/
bool Overlay(array srcLayers, wkLayer layerTar, array idFields, double eps)
{
	if(srcLayers.getSize()==0 || srcLayers.getSize()!=idFields.getSize())
	{
		return false;
	}
	if(layerTar.handle()==0)
	{
		return false;
	}

	array indexs; indexs.removeAll();
	for(int i=0; i<srcLayers.getSize(); i++)
	{
		wkLayer layerSrc=srcLayers[i];
		if(layerSrc.handle()==0 || layerSrc.handle()==layerTar.handle()) //Դ㲻ܰĿ
		{
			return false;
		}
		string sField=idFields[i];
		int nIndex=AddFieldToLayer(layerTar, sField, "int");
		if(nIndex==-1)
		{
			return false;
		}
		indexs.add(nIndex);
	}

	//͹
	layerTar.setEditable(true);
	wkClean cln;
	if(!cln.build(srcLayers, false, eps)) //clean
	{
		return false;
	}
//	array layerLines={layerTar};
//	if(!cln.build(layerLines, false, 1e-006)) //ٹ
//	{
//		return false;
//	}

	int count=layerTar.getFeatureCount();

	//ɾ
	wkView view;
	view.waitStart("ɾ...");
	for(i=count-1; i>=0; i--)
	{
		wkFeature feaTar=layerTar.getFeatureAt(i);
		wkGeometry geomTar=feaTar.getGeometry();
		if(geomTar.type()!=4)
		{
			layerTar.deleteFeature(feaTar.getId());
			continue;
		}
	}
	layerTar.loadInfo(true);
	
	count=layerTar.getFeatureCount();
	string msg;
	msg.format("ڽϵ..., %d -", count);        
	int clockPreSec;
	int start=clock(clockPreSec);
	for(i=count-1; i>=0; i--)
	{
		int end=clock();
		if(end-start>clockPreSec)
		{
			view.waitMessage(msg, count-i);
			start=end;
		}
		wkFeature feaTar=layerTar.getFeatureAt(i);
		wkGeometry geomTar=feaTar.getGeometry();
		wkPoint pt=geomTar.centroid();
		
		bool bFind=false;
		for(int j=0; j<srcLayers.getSize(); j++)
		{
			wkLayer layerSrc=srcLayers[j];
			layerSrc.clearSelection();
			if(layerSrc.searchFeature(pt)>0)
			{
				wkFeature feaSrc=layerSrc.getSelectionAt(0);
				feaTar.setInfo(layerTar, indexs[j], toString(feaSrc.getId()));
				bFind=true;
			}
		}
		if(!bFind)
		{
			layerTar.deleteFeature(feaTar.getId());
		}
	}
	layerTar.loadInfo(false);
	view.waitEnd();

	return true;
}

/*;: ͼӲϵ, ʹboolOp
: 1. array srcLayers: ӵԴ
          2. wkLayer layer: Ӻ󱣴ͼ
		  3. array idFields: ʶֶ, ¼ӺԴFeatureID, Դһ
		  4. double eps: Ӿ
:
  ֵ: Ƿӳɹ
  ע:   ҪһΪȫ
*/
bool OverlayOp(array srcLayers, wkLayer layerTar, array idFields, double eps)
{
	if(srcLayers.getSize()==0 || srcLayers.getSize()!=idFields.getSize())
	{
		return false;
	}
	if(layerTar.handle()==0)
	{
		return false;
	}

	array indexs; indexs.removeAll();
	for(int i=0; i<srcLayers.getSize(); i++)
	{
		wkLayer layerSrc=srcLayers[i];
		if(layerSrc.handle()==0 || layerSrc.handle()==layerTar.handle()) //Դ㲻ܰĿ
		{
			return false;
		}
		string sField=idFields[i];
		int nIndex=AddFieldToLayer(layerTar, sField, "int");
		if(nIndex==-1)
		{
			return false;
		}
		indexs.add(nIndex);
	}

	wkView view;
	string msg;

	wkLayer layerBase=srcLayers[0];
	
	//: ҪһΪȫ
	view.waitStart("");
	int clockPreSec;
	int start=clock(clockPreSec);
	msg.format("ڸ[%s]..., %d -", layerBase.getName(), layerBase.getFeatureCount());
	for(i=0; i<layerBase.getFeatureCount(); i++)
	{
		int end=clock();
		if(end-start>clockPreSec)
		{
			view.waitMessage(msg, i+1);
			start=end;
		}

		wkFeature feaBase=layerBase.getFeatureAt(i);
		wkGeometry geomBase=feaBase.getGeometry();
		if(geomBase.type()==4)
		{
			layerTar.addFeature(geomBase);
		}
	}

	//
	for(i=1; i<srcLayers.getSize(); i++)
	{
		wkLayer layerCut=srcLayers[i];

		msg.format("ڵ[%s]..., %d -", layerCut.getName(), layerCut.getFeatureCount());
		for(int j=0; j<layerCut.getFeatureCount(); j++)
		{
			int end=clock();
			if(end-start>clockPreSec)
			{
				view.waitMessage(msg, j+1);
				start=end;
			}

			wkFeature feaCut=layerCut.getFeatureAt(j);
			wkGeometry geomCut=feaCut.getGeometry();
			if(geomCut.type()!=4)
			{
				continue;
			}

			layerTar.clearSelection();
			layerTar.searchFeature(geomCut, 4|8|32); //ཻ++ڴ
			for(int k=0; k<layerTar.getSelectionCount(); k++)
			{
				wkFeature feaTar=layerTar.getSelectionAt(k);
				wkGeometry geomTar=feaTar.getGeometry();

				wkGeometry geomPub=geomTar.boolOp(geomCut, 0); //
				wkGeometry geomDif=geomTar.boolOp(geomCut, 2); //
				if(geomPub.handle()!=0 && geomPub.type()==4 &&
				   geomDif.handle()!=0 && geomDif.type()==4 &&
				   geomPub.area()>0.1 && geomDif.area()>0.1)
				{
					geomPub.rebuild();
					geomDif.rebuild();
					geomPub.putInOrder();
					geomDif.putInOrder();
					for(int n=0; n<geomPub.getPointCount(); n++)
					{
						layerTar.addFeature(geomPub.getPolygonAt(n));
					}
					for(n=0; n<geomDif.getPointCount(); n++)
					{
						layerTar.addFeature(geomDif.getPolygonAt(n));
					}
					layerTar.deleteFeature(feaTar.getId());
				}
			}
		}
	}

	layerTar.loadInfo(true);
	int count=layerTar.getFeatureCount();
	msg.format("ڽϵ..., %d -", count);        
	for(i=count-1; i>=0; i--)
	{
		int end=clock();
		if(end-start>clockPreSec)
		{
			view.waitMessage(msg, count-i);
			start=end;
		}
		wkFeature feaTar=layerTar.getFeatureAt(i);
		wkGeometry geomTar=feaTar.getGeometry();
		wkPoint pt=geomTar.centroid();
		
		bool bFind=false;
		for(int j=0; j<srcLayers.getSize(); j++)
		{
			wkLayer layerSrc=srcLayers[j];
			layerSrc.clearSelection();
			if(layerSrc.searchFeature(pt)>0)
			{
				wkFeature feaSrc=layerSrc.getSelectionAt(0);
				feaTar.setInfo(layerTar, indexs[j], toString(feaSrc.getId()));
				bFind=true;
			}
		}
		if(!bFind)
		{
			layerTar.deleteFeature(feaTar.getId());
		}
	}
	layerTar.loadInfo(false);
	view.waitEnd();

	return true;
}

/*;: Բеﰴռλ
: 1. wkLayer layer: 
          2. string fieldNO :űֶ
		  3. int sortType: 򷽷 0-ͱ, 1-Zͱ
		  4. bool onlySortSelection: ѡм
:
  ֵ: Ƿӳɹ
  ע:   
*/
bool SortFeature(wkLayer layer, string sortField, int sortType, bool sortSelection)
{
	if(layer.handle()==0)
	{
		return false;
	}
	int index=layer.getFieldIndex(sortField);
	if(index==-1)
	{
		return false;
	}
	
	if(sortType!=0)
	{
		sortType=1;
	}
	
	array ids; ids.removeAll();
	array geoms; geoms.removeAll();
	int count = sortSelection? layer.getSelectionCount() : layer.getFeatureCount();
	for(int i=0; i<count; i++)
	{
		wkFeature feature = sortSelection? layer.getSelectionAt(i) : layer.getFeatureAt(i);
		ids.add(feature.getId());
		wkGeometry geom=feature.getGeometry();
		geoms.add(geom.handle());
	}
	if(ids.getSize()==0)
	{
		return true;
	}
	
	array orders; orders.removeAll();
	orders = WsSortByPolygon(geoms, sortType); //0-ͱ, 1-Zͱ
	if (orders.getSize() != ids.getSize())
	{
		return false;
	}
	for (i=0; i<ids.getSize();i++)
	{
		wkFeature feature=layer.getFeature(ids[i]);
		int order=orders[i];
		feature.setInfo(layer,index,toString(order+1));
	}	
	
	return true;
}

/*;: ִгɹĽűв¼
: 1. wkDb db: ݿ
          2. string TABLE_LOG :¼
		  3. int menu:˵ID
		  4. int item: Ӳ˵ID
		  5. string note: ¼硰1ʾִгɹΪִвɹ
:
  ֵ: 
  ע:   
*/
//¼
bool AssureActLogTable(wkDb db,string TABLE_LOG)
{
	if (db.isTableExisted(TABLE_LOG))
	{
		return true;
	}

	string sql;
	sql.format("create table [%s]([ID] AUTOINCREMENT PRIMARY KEY, [Menu] int, [Item] int, [Note] varchar(255))", TABLE_LOG);
	return db.execSQL(sql, true);
}
//¼ִеĲ
void LogAction(wkDb db, string TABLE_LOG, int menu, int item, string note)
{
	if(!AssureActLogTable(db,TABLE_LOG))
	{
		return;
	}

	string sql;
	sql.format("select [ID] from [%s] where [Menu]=%d and [Item]=%d", TABLE_LOG, menu, item);
	array vals=db.getDataBySQL(sql, 1);
	if(vals.getSize()==0)
	{
		sql.format("insert into [%s]([Menu], [Item], [Note]) values(%d, %d, '%s')", TABLE_LOG, menu, item, note);
		db.execSQL(sql, true);
	}
	else
	{
		sql.format("update [%s] set [Note]='%s' where [Menu]=%d and [Item]=%d", TABLE_LOG, note, menu, item);
		db.execSQL(sql, true);
	}
}

void layerControl(array layers)
{
	wkGeoset geoset;
	array AllLayers = {"DM_M", "DM_X", "DM_D", "DM_Z", "GXSS_X", "GXSS_D", "GXSS_Z", \
		"JMD_M", "JMD_X", "JMD_D", "JMD_Z", "JTSS_M", "JTSS_X", "JTSS_D",\
		"JTSS_Z", "SXSS_M", "SXSS_X", "SXSS_D", "SXSS_Z", "ZBTZ_M", \
		"ZBTZ_X", "ZBTZ_D", "ZBTZ_Z"};
	int c=0;
	for (int i=0; i<AllLayers.getSize(); i++)
	{
		wkLayer layer = geoset.getLayer(AllLayers[i]);
		if (layer.handle() == 0)
		{
			continue;
		}
		layer.setOrder(c);
		bool is = true;
		for (int j=layers.getSize()-1; j>=0; j--)
		{
			if (layer.handle() == layers[j].handle())
			{
				layer.setEditable(true);
				is = false;
				break;
			}
		}
		if (is)
		{
			layer.setVisiable(false);
		}	
		c++;
	}
}